//
//  MathematicaRandom.java
//  LocalInteractions
//
//  Created by Jason on Fri Mar 19 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//
import java.util.Random;
import com.wolfram.jlink.*;

public class MathematicaRandom extends Random {

	public MathematicaRandom( long seed ) {
		super(seed);
	}
	
	public MathematicaRandom() {
		super();
	}
/*
	public int next(int bits) throws MathLinkException {
		KernelLink kl = StdLink.getLink();
		kl.evaluate("Plus @@ Table[ 2^i*Random[Integer], {i,0," + bits + "}]");
		kl.waitForAnswer();
		int output = kl.getInteger();
		kl.newPacket();
		return output;			
	}
 */
	
	public boolean nextBoolean() {
		KernelLink kl = StdLink.getLink();
		try {
			kl.evaluate("{True,False}[[ Random[Integer,{1,2}] ]]");
			kl.waitForAnswer();
			boolean output = kl.getBoolean();
			kl.newPacket();
			return output;			
		}
		catch (MathLinkException e) {
			kl.clearError();
			System.out.println(e.getMessage());
			return super.nextBoolean();
		}		
	}
	
	public double nextDouble() {
		KernelLink kl = StdLink.getLink();
		try {
			kl.evaluate("Random[]");
			kl.waitForAnswer();
			double output = kl.getDouble();
			kl.newPacket();
			return output;			
		}
		catch (MathLinkException e) {
			kl.clearError();
			System.out.println(e.getMessage());
			return super.nextDouble();
		}		
	}
	
	public float nextFloat() {
		KernelLink kl = StdLink.getLink();
		try {
			kl.evaluate("Random[]");
			kl.waitForAnswer();
			float output = (float) kl.getDouble();
			kl.newPacket();
			return output;			
		}
		catch (MathLinkException e) {
			kl.clearError();
			System.out.println(e.getMessage());
			return super.nextFloat();
		}		
	}
	
	public int nextInt(int n) {
		KernelLink kl = StdLink.getLink();
		try {
			kl.evaluate("Random[Integer,{0," + (n-1) + "}]");
			kl.waitForAnswer();
			int output = kl.getInteger();
			kl.newPacket();
			return output;			
		}
		catch (MathLinkException e) {
			kl.clearError();
			System.out.println(e.getMessage());
			return super.nextInt( n );
		}		
	}
	
	public int nextInt() {
		KernelLink kl = StdLink.getLink();
		try {
			kl.evaluate("Random[Integer,{0,2^32-1}]");
			kl.waitForAnswer();
			int output = kl.getInteger();
			kl.newPacket();
			return output;			
		}
		catch (MathLinkException e) {
			kl.clearError();
			System.out.println(e.getMessage());
			return super.nextInt();
		}		
	}
	
	public double nextGaussian() {
		KernelLink kl = StdLink.getLink();
		try {
			kl.evaluate("Random[NormalDistribution[0,1]]");
			kl.waitForAnswer();
			double output = kl.getDouble();
			kl.newPacket();
			return output;			
		}
		catch (MathLinkException e) {
			kl.clearError();
			System.out.println(e.getMessage());
			return super.nextGaussian( );
		}		
	}
	
	public long nextLong() {
		KernelLink kl = StdLink.getLink();
		try {
			kl.evaluate("Random[Integer,{0,2^64-1}]");
			kl.waitForAnswer();
			long output = kl.getLongInteger();
			kl.newPacket();
			return output;			
		}
		catch (MathLinkException e) {
			kl.clearError();
			System.out.println(e.getMessage());
			return super.nextLong( );
		}		
	}

	public void setSeed(long seed) {
		KernelLink kl = StdLink.getLink();
		try {
			kl.evaluate("SeedRandom[" + seed + "]");
			kl.waitForAnswer();
			kl.newPacket();
			return;			
		}
		catch (MathLinkException e) {
			kl.clearError();
			System.out.println(e.getMessage());
			return;
		}		
	}
	
	public void nextBytes(byte[] bytes) {
		KernelLink kl = StdLink.getLink();
		try {
			int i = java.lang.reflect.Array.getLength(bytes);
			kl.evaluate("Table[Random[Integer,{0,255}], {" + i + "}]");
			kl.waitForAnswer();
			byte[] newBytes = kl.getByteArray1();

			for (int j=0; j<i; j++)
				bytes[j] = newBytes[j];
			
			kl.newPacket();
			return;			
		}
		catch (MathLinkException e) {
			kl.clearError();
			System.out.println(e.getMessage());
			super.nextBytes(bytes);
			return;
		}		
	}
}
