//
//  MoveTowardsBestNeighbor.java
//  LocalInteractions
//
//  Created by Jason on Fri Mar 19 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//
import java.util.*;

public class MoveTowardsBestNeighbor implements LearningRule {

	public int nextStrategy(Agent agent) {
			
		LinkedList top_scorers = new LinkedList();
		
		double score_to_beat = agent.getScore();
			
		Iterator i = agent.constructUpdateNeighborhood().iterator();
			
		while (i.hasNext()) {
			Agent n = (Agent)i.next();
			
			if (n.getScore() > score_to_beat) {
				score_to_beat = n.score;
				top_scorers.clear();
				top_scorers.add(n);
			}
			else if (n.getScore() == score_to_beat) 
				top_scorers.add(n);
		}
		
		if (score_to_beat > agent.getScore()) {
			int size = top_scorers.size();
			int randomInt = agent.parentModel.random.nextInt( size );
			
			int s = agent.getStrategy();
			int nextS = ((Agent)top_scorers.get(randomInt)).getStrategy();
			
			// notice that the following is guaranteed to always return a
			// strategy that falls within the valid bounds: >= 0 and <= maximum strategy value
			if (nextS > s)
				return s+1;
			else if (nextS < s)
				return s-1;
			else
				return s;
		}
		else 
			return agent.getStrategy();
	}    
	
}
