//
//  Game.java
//  MathSwingJava
//
//  Created by Jason Alexander on Mon Sep 15 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//
import java.lang.reflect.*;

public class PayoffMatrix extends Object {

    double payoffMatrix[][][];
    int numberOfStrategies;
	
    public PayoffMatrix(double matrix[][][]) {
		super();
		
        int row, col, entry, numRows, numCols;
		
        numRows = Array.getLength(matrix);
		//System.out.println("Matrix has " + numRows + " rows");
		numberOfStrategies = numRows;
		
        numCols = Array.getLength(matrix[0]);
		//System.out.println("Matrix has " + numCols + " cols");
        payoffMatrix = new double[numRows][numCols][2];

        for (row=0; row<numRows; row++) {
            for (col=0; col<numCols; col++) {
                payoffMatrix[row][col][0] = matrix[row][col][0];
				payoffMatrix[row][col][1] = matrix[row][col][1];
            }
        }
    }

	public int getNumberOfStrategies() {
		return numberOfStrategies;
	}
	
    public double[][][] getPayoffMatrix() { return payoffMatrix; }

	final static int ROW = 0;
	final static int COLUMN = 1;
	
    public double getPayoff(int row, int col, int role) {
        return payoffMatrix[row][col][role];
    }

    public void setPayoffMatrix(double matrix[][][]) {
        int row, col, entry, numRows, numCols;
		
        numRows = Array.getLength(matrix);
        numCols = Array.getLength(matrix[0]);
        payoffMatrix = new double[numRows][numCols][2];
		
        for (row=0; row<numRows; row++) {
            for (col=0; col<numCols; col++) {
                payoffMatrix[row][col][0] = matrix[row][col][0];
				payoffMatrix[row][col][1] = matrix[row][col][1];
            }
        }
    }
    
}
