(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     84260,       1332]*)
(*NotebookOutlinePosition[     87473,       1413]*)
(*  CellTagsIndexPosition[     87362,       1406]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["EditGraph", "ObjectName",
  CellTags->{"b:5", "LocalInteractions:12"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["EditGraph[",
    FontFamily->"Courier"],
  Cell[BoxData[
      FormBox[
        StyleBox[\(\(graph\)\(\ \)\),
          FontSlant->"Italic"], TraditionalForm]]],
  StyleBox["]",
    FontFamily->"Courier"],
  " launches Levon Lloyd's Java based graph editor with the specified graph \
preloaded. "
}], "Usage",
  CellTags->{"b:5", "LocalInteractions:12"}],

Cell[TextData[{
  "\[FilledSmallSquare] To return the graph to ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ", it must either be saved to disk as a file or copied to the clipboard and \
then pasted back into the front end."
}], "Notes",
  CellTags->{"b:5", "LocalInteractions:12"}],

Cell[CellGroupData[{

Cell["Example", "ExampleSection",
  CellTags->{"b:5", "LocalInteractions:12"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(ShowGraph[PetersenGraph];\)\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->{"b:5", "LocalInteractions:12"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0221976 0.973522 0.0465153 0.930307 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 0 0 r
.005 w
[ ] 0 setdash
.52945 .72674 m
.25051 .35987 L
s
.52945 .72674 m
.52945 .27326 L
s
.52945 .72674 m
.60654 .95348 L
s
.25051 .64013 m
.52945 .27326 L
s
.25051 .64013 m
.70184 .5 L
s
.25051 .64013 m
.04868 .78027 L
s
.25051 .35987 m
.70184 .5 L
s
.25051 .35987 m
.04868 .21973 L
s
.52945 .27326 m
.60654 .04652 L
s
.70184 .5 m
.95132 .5 L
s
.60654 .95348 m
.04868 .78027 L
s
.60654 .95348 m
.95132 .5 L
s
.04868 .78027 m
.04868 .21973 L
s
.04868 .21973 m
.60654 .04652 L
s
.60654 .04652 m
.95132 .5 L
s
.025 w
.52945 .72674 Mdot
.25051 .64013 Mdot
.25051 .35987 Mdot
.52945 .27326 Mdot
.70184 .5 Mdot
.60654 .95348 Mdot
.04868 .78027 Mdot
.04868 .21973 Mdot
.60654 .04652 Mdot
.95132 .5 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[2]:=",
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00[Oooool3o`00073ooooo002/ooooo`Go0000Koooool00:_ooooo1ol0001^ooooo`00Zooo
ool7o`0006kooooo002Yooooo`Wo0000K_ooool00:Kooooo0ol00003ooooo`Go0000Koooool00:?o
oooo0ol00007ooooo`Co0000Koooool00:3ooooo0ol0000:ooooo`05o`000?ooooooooooooooool0
0000K_ooool009cooooo1?l0000<ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
K?ooool009Wooooo0ol0000@ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Jooo
ool009Kooooo0ol0000Cooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0J_ooool0
09?ooooo0ol0000Eooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0JOooool008oo
oooo1?l0000Hooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0JOooool008cooooo
0ol0000Looooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0J?ooool008Wooooo0ol0
000Nooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Ioooool008Kooooo0ol0000Q
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0I_ooool008?ooooo0ol0000Toooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0IOooool007oooooo1?l0000Vooooo`03
o`000?oooooooooo00cooooo00?o0000ooooooooool0IOooool007cooooo0ol0000Zooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool0I?ooool007Wooooo0ol0000]ooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool0Hoooool007Kooooo0ol0000_ooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool0H_ooool007;ooooo1?l0000booooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool0H_ooool006oooooo0ol0000eooooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0HOooool006cooooo0ol0000hooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0H?ooool006Wooooo0ol0000kooooo`03o`000?oooooooooo01Cooooo00?o
0000ooooooooool0Goooool006Kooooo0ol0000mooooo`03o`000?oooooooooo01Gooooo00?o0000
ooooooooool0Goooool006;ooooo1?l00010ooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool0G_ooool005oooooo0ol00014ooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool0GOooool005cooooo0ol00016ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
G?ooool005Wooooo0ol00019ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0G?oo
ool005Gooooo1?l0001<ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0Foooool0
05;ooooo0ol0001?ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0F_ooool004oo
oooo0ol0001Booooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0FOooool004cooooo
0ol0001Eooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0FOooool004Wooooo0ol0
001Gooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0F?ooool004Gooooo1?l0001J
ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0Eoooool004;ooooo0ol0001Moooo
o`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0E_ooool003oooooo0ol0001Pooooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool0EOooool003cooooo0ol0001Sooooo`03o`00
0?oooooooooo02?ooooo00?o0000ooooooooool0EOooool003Sooooo1?l0001Uooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool0E?ooool003Gooooo0ol0001Yooooo`03o`000?oooooo
oooo02Kooooo00?o0000ooooooooool0Doooool003;ooooo0ol0001/ooooo`03o`000?oooooooooo
02Oooooo00?o0000ooooooooool0D_ooool002oooooo0ol0001^ooooo`03o`000?oooooooooo02So
oooo00?o0000ooooooooool0D_ooool002cooooo0ol0001aooooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool0DOooool002Sooooo1?l0001dooooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool0D?ooool002Gooooo0ol0001gooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool0Coooool002;ooooo0ol0001jooooo`03o`000?oooooooooo02cooooo00?o0000oooo
ooooool0Coooool001oooooo0ol0001mooooo`03o`000?oooooooooo02gooooo00?o0000oooooooo
ool0C_ooool001_ooooo1?l0001oooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0
COooool001Sooooo0ol00023ooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0C?oo
ool000cooooo0ol00006ooooo`?o0000Q_ooool00ol0003oooooooooo`0`ooooo`03o`000?oooooo
oooo04cooooo000;ooooo`Go00000_ooool3o`0008Sooooo00?o0000ooooooooool0<_ooool00ol0
003oooooooooo`1;ooooo`002_ooool8o`0008_ooooo00?o0000ooooooooool0<oooool00ol0003o
ooooooooo`1:ooooo`002_ooool7o`0008_ooooo00?o0000ooooooooool0=Oooool00ol0003ooooo
ooooo`19ooooo`002_ooool7o`0008_ooooo00?o0000ooooooooool0=Oooool00ol0003ooooooooo
o`19ooooo`002oooool7o`0008[ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`18
ooooo`003?ooool3o`0000?ooooo00?o0000ooooooooool0Q_ooool00ol0003oooooooooo`0hoooo
o`03o`000?oooooooooo04Oooooo000=ooooo`03o`000?oooooooooo00?ooooo0_l00026ooooo`03
o`000?oooooooooo03Wooooo00?o0000ooooooooool0A_ooool000gooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`23ooooo`03o`000?oooooooooo03[ooooo00?o0000ooooooooool0
AOooool000gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`21ooooo`03o`000?oo
oooooooo03_ooooo00?o0000ooooooooool0AOooool000gooooo00?o0000ooooooooool01oooool2
o`00087ooooo00?o0000ooooooooool0??ooool00ol0003oooooooooo`14ooooo`003Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo07kooooo00?o0000ooooooooool0?Oooool00ol0
003oooooooooo`13ooooo`003Oooool00ol0003oooooooooo`0:ooooo`;o0000OOooool00ol0003o
ooooooooo`0oooooo`03o`000?oooooooooo04;ooooo000=ooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool0N_ooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo04;ooooo
000=ooooo`03o`000?oooooooooo00gooooo0_l0001jooooo`03o`000?oooooooooo043ooooo00?o
0000ooooooooool0@Oooool000gooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`1d
ooooo`?o0000A?ooool00ol0003oooooooooo`10ooooo`003Oooool00ol0003oooooooooo`0@oooo
o`;o0000Loooool5o`0004Cooooo00?o0000ooooooooool0?oooool000gooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`1_ooooo`Oo0000@oooool00ol0003oooooooooo`0oooooo`00
3Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo06kooooo1ol00014ooooo`03o`00
0?oooooooooo03kooooo000=ooooo`03o`000?oooooooooo01Cooooo0_l0001^ooooo`Oo0000AOoo
ool00ol0003oooooooooo`0mooooo`003Oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooo
oooo06cooooo1Ol00017ooooo`03o`000?oooooooooo03cooooo000=ooooo`03o`000?oooooooooo
01Oooooo0_l0001/ooooo`Co0000B?ooool00ol0003oooooooooo`0looooo`003Oooool00ol0003o
ooooooooo`0Iooooo`03o`000?oooooooooo06Sooooo00Co0000oooooooooooo0000B_ooool00ol0
003oooooooooo`0kooooo`003Oooool00ol0003oooooooooo`0Jooooo`;o0000J?ooool01?l0003o
ooooooooool0001;ooooo`03o`000?oooooooooo03[ooooo000=ooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool0I?ooool01Ol0003ooooooooooooooooo000004cooooo00?o0000oooo
ooooool0>Oooool000gooooo00?o0000ooooooooool07Oooool2o`0006?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo03Wooooo000=ooooo`03o`00
0?oooooooooo01oooooo00?o0000ooooooooool0Goooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo04_ooooo00?o0000ooooooooool0>?ooool000gooooo00?o0000ooooooooool08?oo
ool2o`0005oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1<ooooo`03o`000?oo
oooooooo03Oooooo000=ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0Foooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool0=_ooool0
00gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`1Iooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`0fooooo`003Oooool00ol0003o
ooooooooo`0Tooooo`;o0000F?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo04ko
oooo00?o0000ooooooooool0=Oooool000gooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`1Dooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Coooool00ol0003ooooo
ooooo`0dooooo`003Oooool00ol0003oooooooooo`0Wooooo`;o0000E?ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool0<oooool000gooooo00?o0000
ooooooooool0:Oooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0booooo`003Oooool00ol0003oooooooooo`0Zoooo
o`;o0000Coooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo057ooooo00?o0000oooo
ooooool0<_ooool000gooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`1;ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`0aooooo`00
3Oooool00ol0003oooooooooo`0]ooooo`;o0000Boooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo05?ooooo00?o0000ooooooooool0<?ooool000gooooo00?o0000ooooooooool0;ooo
ool00ol0003oooooooooo`17ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0E?oo
ool00ol0003oooooooooo`0_ooooo`003Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooo
oooo04Gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`1Dooooo`03o`000?oooooo
oooo02oooooo000=ooooo`03o`000?oooooooooo037ooooo0_l00014ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool0EOooool00ol0003oooooooooo`0^ooooo`003Oooool00ol0003o
ooooooooo`0cooooo`03o`000?oooooooooo00?o0000?_ooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo05Kooooo00?o0000ooooooooool0;Oooool000gooooo00?o0000ooooooooool0
=?ooool6o`0003cooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`1Gooooo`03o`00
0?oooooooooo02cooooo000=ooooo`03o`000?oooooooooo03Cooooo1ol0000jooooo`03o`000?oo
oooooooo00oooooo00?o0000ooooooooool0Eoooool00ol0003oooooooooo`0/ooooo`003Oooool0
0ol0003oooooooooo`0dooooo`Oo0000>Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo
oooo05Sooooo00?o0000ooooooooool0:oooool000gooooo00?o0000ooooooooool0=?ooool9o`00
03Oooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`1Iooooo`03o`000?oooooooooo
02[ooooo000=ooooo`03o`000?oooooooooo03Gooooo1Ol00003ooooo`?o0000<oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo05[ooooo00?o0000ooooooooool0:Oooool000gooooo
00?o0000ooooooooool0=_ooool4o`0000Kooooo0ol0000_ooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool0F_ooool00ol0003oooooooooo`0Yooooo`003Oooool00ol0003ooooooooo
o`0jooooo`03o`000?oooooooooo00Kooooo1?l0000Zooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool0Foooool00ol0003oooooooooo`0Xooooo`003Oooool00ol0003oooooooooo`0j
ooooo`03o`000?oooooooooo00[ooooo0ol0000Wooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool0G?ooool00ol0003oooooooooo`0Wooooo`003Oooool00ol0003oooooooooo`0koooo
o`03o`000?oooooooooo00cooooo0ol0000Sooooo`03o`000?oooooooooo01Cooooo00?o0000oooo
ooooool0GOooool00ol0003oooooooooo`0Vooooo`003Oooool00ol0003oooooooooo`0looooo`03
o`000?oooooooooo00kooooo0ol0000Oooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool0GOooool00ol0003oooooooooo`0Vooooo`003Oooool00ol0003oooooooooo`0mooooo`03o`00
0?oooooooooo013ooooo1?l0000Jooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0
G_ooool00ol0003oooooooooo`0Uooooo`003Oooool00ol0003oooooooooo`0mooooo`03o`000?oo
oooooooo01Cooooo0ol0000Fooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0Gooo
ool00ol0003oooooooooo`0Tooooo`003Oooool00ol0003oooooooooo`0nooooo`03o`000?oooooo
oooo01Kooooo0ol0000Cooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0H?ooool0
0ol0003oooooooooo`0Sooooo`003Oooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo
01Sooooo0ol0000?ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0HOooool00ol0
003oooooooooo`0Rooooo`003Oooool00ol0003oooooooooo`10ooooo`03o`000?oooooooooo01[o
oooo1?l0000:ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0HOooool00ol0003o
ooooooooo`0Rooooo`003Oooool00ol0003oooooooooo`11ooooo`03o`000?oooooooooo01gooooo
0ol00006ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0H_ooool00ol0003ooooo
ooooo`0Qooooo`003Oooool00ol0003oooooooooo`11ooooo`03o`000?oooooooooo023ooooo0ol0
0003ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0Hoooool00ol0003ooooooooo
o`0Pooooo`003Oooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo02;ooooo0ol0000M
ooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool07oooool000gooooo00?o0000oooo
ooooool0@oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo000000?o00006Oooool00ol0
003oooooooooo`1Tooooo`03o`000?oooooooooo01oooooo000=ooooo`03o`000?oooooooooo04Co
oooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`04ooooo`?o00005_ooool00ol0003o
ooooooooo`1Uooooo`03o`000?oooooooooo01kooooo000=ooooo`03o`000?oooooooooo04Cooooo
00?o0000ooooooooool08?ooool00ol0003oooooooooo`07ooooo`?o00004oooool00ol0003ooooo
ooooo`1Vooooo`03o`000?oooooooooo01gooooo000=ooooo`03o`000?oooooooooo04Gooooo00?o
0000ooooooooool07_ooool00ol0003oooooooooo`0;ooooo`?o00004?ooool00ol0003ooooooooo
o`1Wooooo`03o`000?oooooooooo01cooooo000=ooooo`03o`000?oooooooooo04Kooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0?ooooo`Co00003?ooool00ol0003oooooooooo`1W
ooooo`03o`000?oooooooooo01cooooo000=ooooo`03o`000?oooooooooo04Oooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`0Dooooo`?o00002Oooool00ol0003oooooooooo`1Xoooo
o`03o`000?oooooooooo01_ooooo000=ooooo`03o`000?oooooooooo04Oooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`0Gooooo`?o00001_ooool00ol0003oooooooooo`1Yooooo`03
o`000?oooooooooo01[ooooo000=ooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0Kooooo`?o00000oooool00ol0003oooooooooo`1Zooooo`03o`00
0?oooooooooo01Wooooo000=ooooo`03o`000?oooooooooo04Wooooo00?o0000ooooooooool05_oo
ool00ol0003oooooooooo`0Oooooo`Co0000K?ooool00ol0003oooooooooo`0Iooooo`003Oooool0
0ol0003oooooooooo`1:ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool08oooool4
o`0006[ooooo00?o0000ooooooooool06?ooool000gooooo00?o0000ooooooooool0B_ooool00ol0
003oooooooooo`0Dooooo`03o`000?oooooooooo02?ooooo00Co0000oooooooooooooooo0ol0001X
ooooo`03o`000?oooooooooo01Oooooo000=ooooo`03o`000?oooooooooo04_ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo00Cooooo0ol0001Voooo
o`03o`000?oooooooooo01Kooooo000=ooooo`03o`000?oooooooooo04cooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo00Oooooo1?l0001Rooooo`03
o`000?oooooooooo01Kooooo000=ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00_ooooo0ol0001Pooooo`03o`00
0?oooooooooo01Gooooo000=ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo00kooooo0ol0001Nooooo`03o`000?oo
oooooooo01Cooooo000=ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`0Wooooo`03o`000?oooooooooo017ooooo0ol0001Looooo`03o`000?oooooo
oooo01?ooooo000=ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo01Cooooo1?l0001Iooooo`03o`000?oooooooooo
01;ooooo000=ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo01Sooooo0ol0001Fooooo`03o`000?oooooooooo01;o
oooo000=ooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oooooooooo01_ooooo0ol0001Dooooo`03o`000?oooooooooo017ooooo
000=ooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo01kooooo0ol0001Booooo`03o`000?oooooooooo013ooooo000=
ooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0[
ooooo`03o`000?oooooooooo027ooooo1?l0001?ooooo`03o`000?oooooooooo00oooooo000=oooo
o`03o`000?oooooooooo05?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0/oooo
o`03o`000?oooooooooo02Gooooo0ol00006ooooo`?o0000@oooool4o`0000kooooo000=ooooo`03
o`000?oooooooooo05Cooooo00Co0000oooooooooooo0000;oooool00ol0003oooooooooo`0Xoooo
o`?o00000_ooool5o`0004;ooooo1Ol0000=ooooo`003Oooool00ol0003oooooooooo`1Dooooo`04
o`000?ooooooooooo`0002oooooo00?o0000ooooooooool0:oooool8o`00043ooooo1ol0000<oooo
o`003Oooool00ol0003oooooooooo`1Eooooo`;o0000<?ooool00ol0003oooooooooo`0/ooooodko
00003?ooool000gooooo00?o0000ooooooooool0EOooool2o`00033ooooo00?o0000ooooooooool0
:_ooool9o`00043ooooo1ol0000<ooooo`003Oooool00ol0003oooooooooo`1Dooooo`04o`000?oo
ooooooooo`0002oooooo00?o0000ooooooooool09oooool3o`0000?ooooo1Ol00012ooooo`Go0000
3Oooool000gooooo00?o0000ooooooooool0E?ooool01?l0003oooooooooool0000_ooooo`03o`00
0?oooooooooo02Cooooo0ol00007ooooo`?o0000A?ooool3o`0000kooooo000=ooooo`03o`000?oo
oooooooo05?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0/ooooo`03o`000?oo
oooooooo023ooooo1?l0001@ooooo`03o`000?oooooooooo00oooooo000=ooooo`03o`000?oooooo
oooo05;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooo
oooo01gooooo0ol0001Dooooo`03o`000?oooooooooo00oooooo000=ooooo`03o`000?oooooooooo
057ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
01[ooooo0ol0001Fooooo`03o`000?oooooooooo013ooooo000=ooooo`03o`000?oooooooooo057o
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo01Oo
oooo0ol0001Hooooo`03o`000?oooooooooo017ooooo000=ooooo`03o`000?oooooooooo053ooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01?ooooo
1?l0001Jooooo`03o`000?oooooooooo01;ooooo000=ooooo`03o`000?oooooooooo04oooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo013ooooo0ol0
001Nooooo`03o`000?oooooooooo01;ooooo000=ooooo`03o`000?oooooooooo04kooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo00gooooo0ol0001P
ooooo`03o`000?oooooooooo01?ooooo000=ooooo`03o`000?oooooooooo04gooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo00[ooooo0ol0001Roooo
o`03o`000?oooooooooo01Cooooo000=ooooo`03o`000?oooooooooo04gooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00Kooooo1?l0001Tooooo`03
o`000?oooooooooo01Gooooo000=ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo00?ooooo0ol0001Wooooo`03o`00
0?oooooooooo01Kooooo000=ooooo`03o`000?oooooooooo04_ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo00?o0000J_ooool00ol0003ooooooooo
o`0Fooooo`003Oooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool08oooool3o`0006cooooo00?o0000ooooooooool05oooool000gooooo00?o0000oooo
ooooool0B_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01oooooo1Ol0001]oooo
o`03o`000?oooooooooo01Sooooo000=ooooo`03o`000?oooooooooo04Wooooo00?o0000oooooooo
ool05_ooool00ol0003oooooooooo`0Kooooo`?o00001?ooool00ol0003oooooooooo`1Zooooo`03
o`000?oooooooooo01Wooooo000=ooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0Gooooo`?o00001oooool00ol0003oooooooooo`1Zooooo`03o`00
0?oooooooooo01Wooooo000=ooooo`03o`000?oooooooooo04Oooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`0Cooooo`?o00002_ooool00ol0003oooooooooo`1Yooooo`03o`000?oo
oooooooo01[ooooo000=ooooo`03o`000?oooooooooo04Oooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`0?ooooo`Co00003Oooool00ol0003oooooooooo`1Xooooo`03o`000?oooooo
oooo01_ooooo000=ooooo`03o`000?oooooooooo04Kooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0;ooooo`?o00004Oooool00ol0003oooooooooo`1Wooooo`03o`000?oooooooooo
01cooooo000=ooooo`03o`000?oooooooooo04Gooooo00?o0000ooooooooool07_ooool00ol0003o
ooooooooo`07ooooo`?o00005?ooool00ol0003oooooooooo`1Wooooo`03o`000?oooooooooo01co
oooo000=ooooo`03o`000?oooooooooo04Cooooo00?o0000ooooooooool08?ooool00ol0003ooooo
ooooo`03ooooo`?o00005oooool00ol0003oooooooooo`1Vooooo`03o`000?oooooooooo01gooooo
000=ooooo`03o`000?oooooooooo04Cooooo00?o0000ooooooooool08?ooool00ol0003oooooo`00
0003o`0001[ooooo00?o0000ooooooooool0IOooool00ol0003oooooooooo`0Nooooo`003Oooool0
0ol0003oooooooooo`13ooooo`03o`000?oooooooooo023ooooo0ol0000Nooooo`03o`000?oooooo
oooo06Cooooo00?o0000ooooooooool07oooool000gooooo00?o0000ooooooooool0@_ooool00ol0
003oooooooooo`0Nooooo`?o00000oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
06Cooooo00?o0000ooooooooool07oooool000gooooo00?o0000ooooooooool0@Oooool00ol0003o
ooooooooo`0Looooo`?o00001oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo06?o
oooo00?o0000ooooooooool08?ooool000gooooo00?o0000ooooooooool0@Oooool00ol0003ooooo
ooooo`0Hooooo`Co00002_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo06;ooooo
00?o0000ooooooooool08Oooool000gooooo00?o0000ooooooooool0@?ooool00ol0003ooooooooo
o`0Fooooo`?o00003oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo067ooooo00?o
0000ooooooooool08_ooool000gooooo00?o0000ooooooooool0?oooool00ol0003oooooooooo`0D
ooooo`?o00004oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo067ooooo00?o0000
ooooooooool08_ooool000gooooo00?o0000ooooooooool0?_ooool00ol0003oooooooooo`0Boooo
o`?o00005oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo063ooooo00?o0000oooo
ooooool08oooool000gooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0?ooooo`Co
00006_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo05oooooo00?o0000oooooooo
ool09?ooool000gooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`0<ooooo`?o0000
7oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo05kooooo00?o0000ooooooooool0
9Oooool000gooooo00?o0000ooooooooool0??ooool00ol0003oooooooooo`0:ooooo`?o00008ooo
ool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo05gooooo00?o0000ooooooooool09_oo
ool000gooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`08ooooo`?o00009oooool0
0ol0003oooooooooo`0Dooooo`03o`000?oooooooooo05gooooo00?o0000ooooooooool09_ooool0
00gooooo00?o0000ooooooooool0>_ooool00ol0003oooooooooo`05ooooo`Co0000:oooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo05cooooo00?o0000ooooooooool09oooool000go
oooo00?o0000ooooooooool0=_ooool3o`000003ooooool0003ooooo00?ooooo0ol0000_ooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0Foooool00ol0003oooooooooo`0Xooooo`00
3Oooool00ol0003oooooooooo`0eooooo`Go00000_ooool3o`0003?ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`1Jooooo`03o`000?oooooooooo02Wooooo000=ooooo`03o`000?oo
oooooooo03Cooooo2?l0000gooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0F_oo
ool00ol0003oooooooooo`0Yooooo`003Oooool00ol0003oooooooooo`0dooooo`Oo0000>Oooool0
0ol0003oooooooooo`0@ooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool0:_ooool0
00gooooo00?o0000ooooooooool0=?ooool7o`0003Wooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`1Hooooo`03o`000?oooooooooo02_ooooo000=ooooo`03o`000?oooooooooo03?o
oooo1ol0000kooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0Eoooool00ol0003o
ooooooooo`0/ooooo`003Oooool00ol0003oooooooooo`0booooo`04o`000?ooooooooooooooo`?o
0000?Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo05Oooooo00?o0000oooooooo
ool0;?ooool000gooooo00?o0000ooooooooool0<?ooool2o`0004Gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`1Fooooo`03o`000?oooooooooo02gooooo000=ooooo`03o`000?oo
oooooooo02oooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo05Gooooo00?o0000ooooooooool0;_ooool000gooooo00?o0000ooooooooool0;_ooool0
0ol0003oooooooooo`17ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0E?ooool0
0ol0003oooooooooo`0_ooooo`003Oooool00ol0003oooooooooo`0/ooooo`;o0000Boooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo05Cooooo00?o0000ooooooooool0;oooool000go
oooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool0Doooool00ol0003oooooooooo`0`ooooo`003Oooool00ol0003ooooo
ooooo`0Yooooo`;o0000Coooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo05;ooooo
00?o0000ooooooooool0<Oooool000gooooo00?o0000ooooooooool0:?ooool00ol0003ooooooooo
o`1@ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0booooo`003Oooool00ol0003oooooooooo`0Vooooo`;o0000E?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool0<_ooool000gooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`1Eooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool0D?ooool00ol0003oooooooooo`0cooooo`003Oooool00ol0003oooooooooo`0Sooooo`;o
0000F?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo04oooooo00?o0000oooooooo
ool0=?ooool000gooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1Iooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0eooooo`003Ooo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo05_ooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo03Kooooo000=ooooo`03o`000?oooooo
oooo01oooooo0_l0001Oooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0COooool0
0ol0003oooooooooo`0fooooo`003Oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
063ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo
03Oooooo000=ooooo`03o`000?oooooooooo01cooooo0_l0001Sooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0Boooool00ol0003oooooooooo`0hooooo`003Oooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`1:ooooo`03o`000?oooooooooo03Wooooo000=ooooo`03o`000?oooooooooo01Wooooo0_l0
001Xooooo`05o`000?ooooooooooooooool00000C?ooool00ol0003oooooooooo`0iooooo`003Ooo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo06Wooooo00Co0000oooooooooooo0000
Boooool00ol0003oooooooooo`0jooooo`003Oooool00ol0003oooooooooo`0Fooooo`;o0000K?oo
ool00ol0003oooooo`000002o`0004Wooooo00?o0000ooooooooool0>oooool000gooooo00?o0000
ooooooooool05Oooool00ol0003oooooooooo`1]ooooo`Go0000Aoooool00ol0003oooooooooo`0l
ooooo`003Oooool00ol0003oooooooooo`0Cooooo`;o0000Koooool7o`0004Kooooo00?o0000oooo
ooooool0??ooool000gooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`1_ooooo`Oo
0000AOooool00ol0003oooooooooo`0mooooo`003Oooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo073ooooo1ol00014ooooo`03o`000?oooooooooo03kooooo000=ooooo`03o`000?oo
oooooooo00oooooo0_l0001dooooo`Go0000A?ooool00ol0003oooooooooo`0oooooo`003Oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo07Gooooo0ol00015ooooo`03o`000?oooooo
oooo03oooooo000=ooooo`03o`000?oooooooooo00cooooo0_l0001jooooo`03o`000?oooooooooo
04;ooooo00?o0000ooooooooool0@?ooool000gooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`1kooooo`03o`000?oooooooooo043ooooo00?o0000ooooooooool0@Oooool000gooooo
00?o0000ooooooooool02Oooool2o`0007kooooo00?o0000ooooooooool0?oooool00ol0003ooooo
ooooo`12ooooo`003Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo07kooooo00?o
0000ooooooooool0?oooool00ol0003oooooooooo`12ooooo`003Oooool00ol0003oooooooooo`06
ooooo`;o0000P_ooool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo04?ooooo000=oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0P_ooool00ol0003oooooooooo`0loooo
o`03o`000?oooooooooo04Cooooo000=ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0Poooool00ol0003oooooooooo`0kooooo`03o`000?oooooooooo04Gooooo000=ooooo`03o`00
0?oooooooooo00;ooooo0_l00027ooooo`03o`000?oooooooooo03[ooooo00?o0000ooooooooool0
AOooool000cooooo0ol00002ooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool0>Ooo
ool00ol0003oooooooooo`16ooooo`002oooool6o`0008[ooooo00?o0000ooooooooool0>?ooool0
0ol0003oooooooooo`17ooooo`002_ooool7o`0008_ooooo00?o0000ooooooooool0=_ooool00ol0
003oooooooooo`18ooooo`002_ooool7o`0008_ooooo00?o0000ooooooooool0=Oooool00ol0003o
ooooooooo`19ooooo`002_ooool9o`0008Wooooo00?o0000ooooooooool0=Oooool00ol0003ooooo
ooooo`19ooooo`002oooool5o`0000?ooooo0ol00027ooooo`03o`000?oooooooooo03?ooooo00?o
0000ooooooooool0B_ooool000cooooo0ol00007ooooo`?o0000Q?ooool00ol0003oooooooooo`0b
ooooo`03o`000?oooooooooo04_ooooo000Iooooo`?o0000P_ooool00ol0003oooooooooo`0`oooo
o`03o`000?oooooooooo04cooooo000Looooo`Co0000O_ooool00ol0003oooooooooo`0`ooooo`03
o`000?oooooooooo04cooooo000Pooooo`?o0000Noooool00ol0003oooooooooo`0_ooooo`03o`00
0?oooooooooo04gooooo000Sooooo`?o0000NOooool00ol0003oooooooooo`0]ooooo`03o`000?oo
oooooooo04kooooo000Vooooo`?o0000M_ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooo
oooo04oooooo000Yooooo`Co0000L_ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo
04oooooo000]ooooo`?o0000L?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo053o
oooo000`ooooo`?o0000KOooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo057ooooo
000cooooo`?o0000J_ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo05;ooooo000f
ooooo`?o0000J?ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo05;ooooo000ioooo
o`Co0000I?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo05?ooooo000mooooo`?o
0000HOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo05Cooooo0010ooooo`?o0000
Goooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo05Gooooo0013ooooo`?o0000G?oo
ool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo05Gooooo0016ooooo`Co0000FOooool0
0ol0003oooooooooo`0Qooooo`03o`000?oooooooooo05Kooooo001:ooooo`?o0000E_ooool00ol0
003oooooooooo`0Pooooo`03o`000?oooooooooo05Oooooo001=ooooo`?o0000Doooool00ol0003o
ooooooooo`0Oooooo`03o`000?oooooooooo05Sooooo001@ooooo`?o0000DOooool00ol0003ooooo
ooooo`0Mooooo`03o`000?oooooooooo05Wooooo001Cooooo`?o0000C_ooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo05Wooooo001Fooooo`Co0000B_ooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo05[ooooo001Jooooo`?o0000B?ooool00ol0003oooooooooo`0Joooo
o`03o`000?oooooooooo05_ooooo001Mooooo`?o0000AOooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo05cooooo001Pooooo`?o0000@_ooool00ol0003oooooooooo`0Iooooo`03o`00
0?oooooooooo05cooooo001Sooooo`Co0000?oooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo05gooooo001Wooooo`?o0000??ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooo
oooo05kooooo001Zooooo`?o0000>Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo
05oooooo001]ooooo`?o0000=oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo05oo
oooo001`ooooo`?o0000=?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo063ooooo
001cooooo`Co0000<?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo067ooooo001g
ooooo`?o0000;_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo06;ooooo001joooo
o`?o0000:oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo06;ooooo001mooooo`?o
0000:Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo06?ooooo0020ooooo`Co0000
9Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo06Cooooo0024ooooo`?o00008_oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo06Gooooo0027ooooo`?o00008?ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo06Gooooo002:ooooo`?o00007Oooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo06Kooooo002=ooooo`?o00006_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo06Oooooo002@ooooo`Co00005oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo06Sooooo002Dooooo`?o00005?ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo06Wooooo002Gooooo`?o00004Oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo06Wooooo002Jooooo`?o00003oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo06[ooooo002Mooooo`Co00002oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo06_ooooo002Qooooo`?o00002?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo06cooooo002Tooooo`?o00001_ooool3o`000003ooooool0003ooooo06gooooo002W
ooooo`?o00000_ooool5o`0006oooooo002Zooooo`So0000K_ooool00:_ooooo1ol0001^ooooo`00
Zoooool7o`0006kooooo002/ooooo`Go0000Koooool00:gooooo0ol0001`ooooo`00oooooolQoooo
o`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQoooo
o`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {0.0227962, -0.0500053, \
0.00357912, 0.00374538}},
  CellTags->{"b:5", "LocalInteractions:12"}]
}, Open  ]],

Cell[BoxData[
    \(EditGraph[PetersenGraph]\)], "Input",
  CellLabel->"In[3]:=",
  CellTags->{"b:5", "LocalInteractions:12"}],

Cell[TextData[{
  "Choosing \"Copy graph to clipboard\" under the File menu enables the graph \
to be pasted back into the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " notebook after some edits have been made."
}], "Text",
  CellTags->{"b:5", "LocalInteractions:12"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      Graph[{{{1, 3}}, {{1, 4}}, {{2, 4}}, {{2, 5}}, {{3, 5}}, {{6, 7}}, {{7, 
              8}}, {{8, 9}}, {{9, 10}}, {{6, 10}}, {{1, 6}}, {{2, 7}}, {{3, 
              8}}, {{4, 9}}, {{5, 10}}, {{11, 15}}, {{14, 15}}, {{13, 
              14}}, {{12, 13}}, {{11, 12}}, {{1, 13}}, {{3, 15}}, {{4, 
              11}}, {{2, 14}}, {{5, 12}}}, {{{0.45000005, 
              1.4929578}}, {{\(-1.35\), 
              0.98591554}}, {{\(-1.23\), \(-0.8732395\)}}, {{0.3599999, \
\(-1.2450705\)}}, {{1.55, \(-0.005633831\)}}, {{0.539614, 
              1.8035916}}, {{\(-1.5806351\), 
              1.1146809}}, {{\(-1.5806351\), \(-1.1146809\)}}, {{0.539614, \
\(-1.8035916\)}}, {{1.85, 0.0}}, {{\(-0.25\), 0.7605634}}, {{\(-0.75\), 
              0.028169036}}, {{\(-0.22000003\), \(-0.6591549\)}}, {{0.52, \
\(-0.42253518\)}}, {{0.5999999, 0.47887325}}}]\)], "Input",
  CellLabel->"In[19]:=",
  CellTags->{"b:5", "LocalInteractions:12"}],

Cell[BoxData[
    InterpretationBox[\("\[SkeletonIndicator]Graph:<"\[InvisibleSpace]25\
\[InvisibleSpace]", "\[InvisibleSpace]15\[InvisibleSpace]", \
"\[InvisibleSpace]"Undirected"\[InvisibleSpace]">\[SkeletonIndicator]"\),
      SequenceForm[ 
      "\[SkeletonIndicator]Graph:<", 25, ", ", 15, ", ", "Undirected", 
        ">\[SkeletonIndicator]"],
      Editable->False]], "Output",
  CellLabel->"Out[19]=",
  CellTags->{"b:5", "LocalInteractions:12"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(ShowGraph[g];\)\)], "Input",
  CellLabel->"In[20]:=",
  CellTags->{"b:5", "LocalInteractions:12"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0106104 0.962486 0.0459856 0.919711 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 0 0 r
.005 w
[ ] 0 setdash
.58307 .87582 m
.14049 .28018 L
s
.58307 .87582 m
.55936 .18658 L
s
.58307 .87582 m
.60667 .95401 L
s
.58307 .87582 m
.40656 .33407 L
s
.10888 .74818 m
.55936 .18658 L
s
.10888 .74818 m
.87285 .49858 L
s
.10888 .74818 m
.04812 .7806 L
s
.10888 .74818 m
.60151 .39364 L
s
.14049 .28018 m
.87285 .49858 L
s
.14049 .28018 m
.04812 .2194 L
s
.14049 .28018 m
.62258 .62055 L
s
.55936 .18658 m
.60667 .04599 L
s
.55936 .18658 m
.39866 .69146 L
s
.87285 .49858 m
.95188 .5 L
s
.87285 .49858 m
.26694 .50709 L
s
.60667 .95401 m
.04812 .7806 L
s
.60667 .95401 m
.95188 .5 L
s
.04812 .7806 m
.04812 .2194 L
s
.04812 .2194 m
.60667 .04599 L
s
.60667 .04599 m
.95188 .5 L
s
.39866 .69146 m
.26694 .50709 L
s
.39866 .69146 m
.62258 .62055 L
s
.26694 .50709 m
.40656 .33407 L
s
.40656 .33407 m
.60151 .39364 L
s
.60151 .39364 m
.62258 .62055 L
s
.025 w
.58307 .87582 Mdot
.10888 .74818 Mdot
.14049 .28018 Mdot
.55936 .18658 Mdot
.87285 .49858 Mdot
.60667 .95401 Mdot
.04812 .7806 Mdot
.04812 .2194 Mdot
.60667 .04599 Mdot
.95188 .5 Mdot
.39866 .69146 Mdot
.26694 .50709 Mdot
.40656 .33407 Mdot
.60151 .39364 Mdot
.62258 .62055 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[20]:=",
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00[Oooool3o`00073ooooo002/ooooo`Go0000Koooool00:_ooooo1ol0001^ooooo`00Zooo
ool7o`0006kooooo002Yooooo`Wo0000K_ooool00:Kooooo0ol00003ooooo`Go0000Koooool00:;o
oooo1?l00007ooooo`Co0000Koooool009oooooo0ol0000;ooooo`05o`000?ooooooooooooooool0
0000K_ooool009cooooo0ol0000=ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
K?ooool009Wooooo0ol0000@ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Jooo
ool009Gooooo1?l0000Cooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0J_ooool0
09;ooooo0ol0000Fooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0JOooool008oo
oooo0ol0000Iooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0JOooool008_ooooo
1?l0000Looooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0J?ooool008Sooooo0ol0
000Oooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Ioooool008Gooooo0ol0000R
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0I_ooool008;ooooo0ol0000Uoooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0IOooool007kooooo1?l0000Wooooo`03
o`000?oooooooooo00cooooo00?o0000ooooooooool0IOooool007_ooooo0ol0000[ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool0I?ooool007Sooooo0ol0000^ooooo`03o`000?oo
oooooooo00kooooo00?o0000ooooooooool0Hoooool007Cooooo1?l0000`ooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool0H_ooool0077ooooo0ol0000dooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool0H_ooool006kooooo0ol0000gooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool0HOooool006_ooooo0ol0000iooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0H?ooool006Oooooo1?l0000looooo`03o`000?oooooooooo01Cooooo00?o
0000ooooooooool0Goooool006Cooooo0ol0000oooooo`03o`000?oooooooooo01Gooooo00?o0000
ooooooooool0Goooool0067ooooo0ol00012ooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool0G_ooool005gooooo1?l00015ooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool0GOooool005[ooooo0ol00018ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
G?ooool005Oooooo0ol0001;ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0G?oo
ool005Cooooo0ol0001>ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0Foooool0
053ooooo1?l0001@ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0F_ooool004go
oooo0ol0001Dooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0FOooool004[ooooo
0ol0001Gooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0FOooool004Kooooo1?l0
001Iooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0F?ooool004?ooooo0ol0001M
ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0Eoooool0043ooooo0ol0001Poooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool0E_ooool003gooooo0ol0001Rooooo`03
o`000?oooooooooo02?ooooo00?o0000ooooooooool0EOooool003Wooooo1?l0001Uooooo`03o`00
0?oooooooooo02?ooooo00?o0000ooooooooool0EOooool003Kooooo0ol0001Yooooo`03o`000?oo
oooooooo02Cooooo00?o0000ooooooooool0E?ooool003?ooooo0ol0001Yooooo`?o0000:?ooool0
0ol0003oooooooooo`1Cooooo`00;oooool4o`0006_ooooo1Ol0000Xooooo`03o`000?oooooooooo
05;ooooo000/ooooo`?o0000K_ooool7o`0002Oooooo00?o0000ooooooooool0D_ooool002Wooooo
0ol0001aooooo`Oo0000:?ooool00ol0003oooooooooo`1Aooooo`009_ooool3o`0007Cooooo1ol0
000Yooooo`03o`000?oooooooooo053ooooo000Rooooo`Co0000N?ooool5o`0002_ooooo00?o0000
ooooooooool0Coooool001oooooo0ol0001looooo`Co0000;?ooool00ol0003oooooooooo`1?oooo
o`007?ooool3o`0007kooooo00Co0000ooooool0003o0000;_ooool00ol0003oooooooooo`1>oooo
o`006?ooool4o`00083ooooo00?o0000ooooooooool00_l0000_ooooo`03o`000?oooooooooo04go
oooo000Eooooo`?o0000Q?ooool01Ol0003oooooo`000?oooooo0000033ooooo00?o0000oooooooo
ool0C?ooool000cooooo0ol00003ooooo`?o0000Q_ooool01_l0003oooooooooool0003oooooo`00
033ooooo00?o0000ooooooooool0C?ooool000_ooooo1ol00028ooooo`07o`000?oooooooooooooo
ool0003oooooo`00000aooooo`03o`000?oooooooooo04_ooooo000:ooooo`Oo0000R?ooool01Ol0
003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`1:
ooooo`002_ooool7o`0008Oooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000c
ooooo`03o`000?oooooooooo04Wooooo000:ooooo`So0000Q_ooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0003?ooooo00?o0000ooooooooool0BOooool000_ooooo1Ol00002oooo
o`03o`000?oooooooooo08;ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo
000003Cooooo00?o0000ooooooooool0B?ooool000cooooo0ol00004ooooo`;o0000POooool00ol0
003oooooooooo`03ooooo`05o`000?ooooooooooooooool00000=Oooool00ol0003oooooooooo`17
ooooo`003Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo07gooooo00?o0000oooo
ooooool01?ooool01Ol0003ooooooooooooooooo000003Kooooo00?o0000ooooooooool0A_ooool0
00gooooo00?o0000ooooooooool01_ooool2o`0007cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo03Cooooo00?o0000ooooooooool0AOooool000go
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1iooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo04Go
oooo000=ooooo`03o`000?oooooooooo00Wooooo0_l0001hooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo04Cooooo
000=ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0M?ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0=_ooool00ol0003ooooooooo
o`13ooooo`003Oooool00ol0003oooooooooo`0<ooooo`;o0000Loooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`12
ooooo`003Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo06oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03Oooooo00?o0000oooo
ooooool0@_ooool000gooooo00?o0000ooooooooool03oooool2o`0006oooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo03Sooooo00?o0000oooooooo
ool0@Oooool000gooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`1[ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0iooooo`03o`00
0?oooooooooo043ooooo000=ooooo`03o`000?oooooooooo01;ooooo0_l0001Zooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0jooooo`03o`000?oo
oooooooo03oooooo000=ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool00ol0001S
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0j
ooooo`03o`000?oooooooooo03oooooo000=ooooo`03o`000?oooooooooo01Gooooo1_l0001Qoooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0koooo
o`03o`000?oooooooooo03kooooo000=ooooo`03o`000?oooooooooo01Gooooo1ol0001Pooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0looooo`03
o`000?oooooooooo03gooooo000=ooooo`03o`000?oooooooooo01Gooooo1ol0001Oooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0mooooo`03o`00
0?oooooooooo03cooooo000=ooooo`03o`000?oooooooooo01Gooooo2Ol0001Looooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0mooooo`03o`000?oo
oooooooo03cooooo000=ooooo`03o`000?oooooooooo01Kooooo1ol000001?oooooo0000o`000?l0
001Hooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0nooooo`03o`000?oooooooooo03_ooooo000=ooooo`03o`000?oooooooooo01Oooooo1?l00002
ooooo`04o`000?ooooooooooooooo`Co0000Doooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0?oooool00ol0003oooooooooo`0jooooo`003Oooool0
0ol0003oooooooooo`0Kooooo`04o`000?ooooooooooo`0000Kooooo0ol0001@ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`10ooooo`03o`000?oo
oooooooo03Wooooo000=ooooo`03o`000?oooooooooo01_ooooo00Co0000oooooooooooooooo0_l0
0007ooooo`?o0000C?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool0@?ooool00ol0003oooooooooo`0iooooo`003Oooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01oooool4o`0004Oooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo047ooooo00?o0000
ooooooooool0>?ooool000gooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`02oooo
o`;o00002oooool3o`0004?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo04;ooooo00?o0000ooooooooool0=oooool000gooooo00?o0000oooooooo
ool07_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00_ooooo0ol0000oooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`13ooooo`03
o`000?oooooooooo03Kooooo000=ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0=ooooo`Co0000>oooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0@oooool00ol0003oooooooooo`0fooooo`003Ooo
ool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Cooooo0_l0000Aooooo`?o0000=ooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0A?oo
ool00ol0003oooooooooo`0eooooo`003Oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool04Oooool3o`0003?ooooo00?o0000ooooooooool03oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo04Gooooo00?o0000ooooooooool0=?ooool0
00gooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`05ooooo`;o00005?ooool4o`00
023ooooo0ol0000;ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`16ooooo`03o`000?oooooooooo03?ooooo000=ooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Eooooo`?o00007?ooool5o`0000Wo
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo04Oo
oooo00?o0000ooooooooool0<_ooool000gooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo01Oooooo0ol0000Hooooo`Oo00002?ooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0Aoooool00ol0003ooooo
ooooo`0booooo`003Oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00Oooooo0_l0
000Jooooo`Co00005?ooool7o`0000Oooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo04Sooooo00?o0000ooooooooool0<Oooool000gooooo00?o0000
ooooooooool09?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01_ooooo0ol0000A
ooooo`Wo00001?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool0B?ooool00ol0003oooooooooo`0`ooooo`003Oooool00ol0003oooooooooo`0Toooo
o`03o`000?oooooooooo00Wooooo0_l0000Nooooo`?o00003oooool5o`0000?ooooo1?l0000Doooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`0_oooo
o`003Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool07_ooool4o`0000_ooooo1?l00006ooooo`Go00004Oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo04Wooooo00?o0000ooooooooool0;oooool000gooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo027ooooo0ol00007ooooo`05o`00
0?ooooooooooooooool000001_ooool00ol0003oooooooooo`02ooooo`?o00003_ooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooooooo04[ooooo00?o0000ooooooooool0;_ooool000gooooo
00?o0000ooooooooool09_ooool00ol0003oooooooooo`0;ooooo`;o00009?ooool3o`0000?ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Kooooo
0ol0000:ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0Boooool00ol0003ooooo
ooooo`0]ooooo`003Oooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool09?ooool4o`0000Gooooo00Go0000ooooooooooooooooo`00000<ooooo`?o0000
1oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0
;?ooool000gooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0<ooooo`;o00009_oo
ool00ol0003oooooo`000002o`0000;ooooo00Co0000oooooooooooo00004?ooool4o`0000?ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo02cooooo
000=ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo00?ooooo0ol000000ooooooo0000ooooo`0Dooooo`?o00004Ooo
ool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo02_ooooo000=ooooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool03_ooool2o`00027ooooo00?o0000ooooooooool01oooool4
o`0001Gooooo1?l0000>ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0:_ooool0
00gooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool02?ooool01?l0003oooooooooooooool3o`0001;ooooo00Co0000
oooooooooooooooo1?l0000:ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0:Ooo
ool000gooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool01oooool2o`0000Kooooo0ol0000>ooooo`03o`000?oooooo
oooo00Kooooo0ol00007ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0:Oooool0
00gooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0?ooooo`;o00006oooool00ol0
003oooooooooo`07ooooo`04o`000?ooooooooooo`0000Sooooo1?l0000:ooooo`03o`000?oooooo
oooo00Wooooo0ol00004ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool0:?ooool0
00gooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01Oooooo00?o0000ooooooooool01oooool01Ol0003ooooooooooooooooo000000cooooo0ol00007
ooooo`03o`000?oooooooooo00cooooo0ol000000ooooooo0000ooooo`1Booooo`03o`000?oooooo
oooo02Oooooo000=ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool04Oooool2o`00
01Kooooo00?o0000ooooooooool02?ooool01Ol0003ooooooooooooooooo000000oooooo0ol00003
ooooo`03o`000?oooooooooo013ooooo1?l0001Booooo`03o`000?oooooooooo02Kooooo000=oooo
o`03o`000?oooooooooo02kooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0?oooo
o`Co00004oooool00ol0003oooooooooo`03o`0000?ooooo0ol00019ooooo`03o`000?oooooooooo
02Kooooo000=ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`0Booooo`Co00004?ooool00ol0003oooooooooo`03ooooo`Oo0000BOooool00ol0003o
ooooooooo`0Uooooo`003Oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01?ooooo
0_l0000@ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo00;ooooo0ol0000=ooooo`03o`000?oooooooooo00Cooooo
1ol00019ooooo`03o`000?oooooooooo02Cooooo000=ooooo`03o`000?oooooooooo033ooooo00?o
0000ooooooooool05?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Gooooo1?l0
0009ooooo`03o`000?oooooooooo00Cooooo1ol0001:ooooo`03o`000?oooooooooo02?ooooo000=
ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool05?ooool2o`0000_ooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool02Oooool3o`0000Kooooo00?o0000ooooooooool01?ooool7o`0004_ooooo00?o0000
ooooooooool08_ooool000gooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0Eoooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool03Oooool3o`0000?ooooo00?o0000oooo
ooooool00_ooool2o`000003ooooool0003o000000?o0000C?ooool00ol0003oooooooooo`0Roooo
o`003Oooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo01Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`0@ooooo`Co00000oooool00ol0003oooooooooo`02ooooo`?o
0000C_ooool00ol0003oooooooooo`0Qooooo`003Oooool00ol0003oooooooooo`0cooooo`03o`00
0?oooooooooo01Kooooo0_l00005ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo01?ooooo1?l00006ooooo`03o`00
0?oooooooooo04kooooo00?o0000ooooooooool08?ooool000gooooo00?o0000ooooooooool0=?oo
ool00ol0003oooooooooo`0Gooooo`05o`000?ooooooooooooooool000002Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool04oooool2o`0000;ooooo
0ol00004ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool07oooool000gooooo00?o
0000ooooooooool0=Oooool00ol0003oooooooooo`0Gooooo`?o00002_ooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool05?ooool00ol0003ooooooooo
o`04ooooo`Go0000D?ooool00ol0003oooooooooo`0Oooooo`003Oooool00ol0003oooooooooo`0e
ooooo`03o`000?oooooooooo01Sooooo0_l00009ooooo`03o`000?oooooooooo00kooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0Booooo`?o00002_ooool3o`0004oooooo00?o0000
ooooooooool07_ooool000gooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooo000000Oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo017ooooo00Co0000oooooooooooo00002_ooool00ol0003oooooooooo`03
o`0004gooooo00?o0000ooooooooool07Oooool000gooooo00?o0000ooooooooool0=oooool00ol0
003oooooooooo`0Eooooo`04o`000?ooooooooooooooo`;o00001?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool04?ooool2o`0000?ooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`03ooooo`Co0000B_ooool00ol0003oooooooooo`0L
ooooo`003Oooool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool01?ooool01?l0003oooooooooool0000Dooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool03oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool01oooool3o`0004Oooooo00?o0000ooooooooool07?ooool000gooooo00?o0000oooo
ooooool0>?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Kooooo0ol0000Doooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02_ooool3o`0004Gooooo00?o0000oooo
ooooool06oooool000gooooo00?o0000ooooooooool0>Oooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00Sooooo0_l0000Eooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool03Oooool2o`0000Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0=ooooo`Co
0000@_ooool00ol0003oooooooooo`0Jooooo`003Oooool00ol0003oooooooooo`0jooooo`03o`00
0?oooooooooo00oooooo00?o0000ooooooooool01oooool01?l0003oooooooooool0000Dooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool04Oooool3o`00043ooooo00?o0000oooooooo
ool06Oooool000gooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool00_ooool2o`0001;ooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`0Dooooo`?o0000?Oooool00ol0003oooooooooo`0Iooooo`003Ooo
ool00ol0003oooooooooo`0kooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`0:ooooo`;o00003?ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo01Oooooo1?l0000jooooo`03o`000?oooooooooo01Sooooo000=ooooo`03o`000?oooooo
oooo03cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Kooooo0_l0000@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool06_ooool3
o`0003Sooooo00?o0000ooooooooool05oooool000gooooo00?o0000ooooooooool0?Oooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool2o`00
00oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Mooooo`?o0000=_ooool00ol0
003oooooooooo`0Fooooo`003Oooool00ol0003oooooooooo`0nooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0;ooooo`;o00003_ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo023ooooo1?l0000booooo`03o`000?oooooooooo01Ko
oooo000=ooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool04?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo02Cooooo0ol0000`ooooo`03o`000?oooooooooo01Gooooo
000=ooooo`03o`000?oooooooooo03oooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Cooooo0_l0000Cooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool09oooool3o`0002kooooo00?o0000ooooooooool05?ooool000gooooo00?o0000
ooooooooool0@?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool04_ooool2o`0000_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Z
ooooo`Co0000:oooool00ol0003oooooooooo`0Cooooo`003Oooool00ol0003oooooooooo`10oooo
o`05o`000?ooooooooooooooool000002_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo01Cooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0^ooooo`?o0000:Oooool0
0ol0003oooooooooo`0Booooo`003Oooool00ol0003oooooooooo`11ooooo`04o`000?oooooooooo
o`0000Wooooo00?o0000ooooooooool05_ooool2o`0000Sooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooooooool2o`0001Oooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`0aooooo`?o00009_ooool00ol0003oooooooooo`0Booooo`003Oooool00ol0003oooooooooo`12
ooooo`;o00002Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo00Kooooo00Go0000
ooooooooooooooooo`000002ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`0dooooo`Co00008oooool00ol0003oooooooooo`0Aooooo`003Oooool0
0ol0003oooooooooo`12ooooo`;o00002?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo
oooo00Gooooo00Go0000oooooooooooo0000ooooo`02o`0001[ooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`0hooooo`?o00008Oooool00ol0003oooooooooo`0@ooooo`003Oooool0
0ol0003oooooooooo`11ooooo`03o`000?oooooo000000Oooooo00?o0000ooooooooool07Oooool2
o`0000Gooooo00?o0000ooooooooool00_l0000Looooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool0>oooool3o`0001oooooo00?o0000ooooooooool03oooool000gooooo00?o0000oooo
ooooool0@?ooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool07oooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooo000001gooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`0mooooo`Co00001_ooool3o`0001;ooooo00?o0000ooooool000000_l0000=
ooooo`003Oooool00ol0003oooooooooo`10ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`0Qooooo`;o00000oooool2o`0001kooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`11ooooo`?o00000_ooool5o`0001;ooooo1Ol0000<oooo
o`003Oooool00ol0003oooooooooo`0kooooo`?o000000?oooooo`000?ooool01Oooool01?l0003o
ooooooooool0000Vooooo`03o`000?oooooo000000;o00007_ooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo04Cooooo2?l0000@ooooo`Oo00002oooool000gooooo00?o0000oooooooo
ool0>_ooool5o`0000Oooooo00?o0000ooooool000009oooool2o`0000;ooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo01goooooA_l0000;ooooo`00
3Oooool00ol0003oooooooooo`0iooooo`Oo00001oooool00ol0003oooooooooo`0NoooooeOo0000
9_ooool9o`00013ooooo1ol0000;ooooo`003Oooool00ol0003oooooooooo`0ioooooboo00001_oo
ool00ol0003oooooooooo`02ooooo`;o00007_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo043ooooo0ol00003ooooo`Go00004_ooool5o`0000cooooo000=ooooo`03o`000?oooooo
oooo03Wooooo1ol00006ooooo`04o`000?ooooooooooo`0002;ooooo0_l00005ooooo`04o`000?oo
oooo0000o`0001cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0mooooo`?o0000
1oooool3o`0001?ooooo1?l0000=ooooo`003Oooool00ol0003oooooooooo`0jooooo`Go00001_oo
ool01Ol0003ooooooooooooooooo0000027ooooo00?o0000ooooooooool01?ooool01_l0003ooooo
ooooool0003oooooo`0001_ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0joooo
o`?o00007oooool00ol0003oooooooooo`0?ooooo`003Oooool00ol0003oooooooooo`0kooooo`Co
00001Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool01Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Sooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`0gooooo`?o00008_ooool00ol0003oooooooooo`0?oooo
o`003Oooool00ol0003oooooooooo`0oooooo`05o`000?ooooooooooooooool000001oooool00ol0
003oooooooooo`0Jooooo`;o00002?ooool01?l0003oooooooooool00003ooooo`;o00006?ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo03Cooooo0ol0000Tooooo`03o`000?oooooo
oooo013ooooo000=ooooo`03o`000?oooooooooo03oooooo00Go0000ooooooooooooooooo`000008
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo037ooooo0ol0000Vooooo`03o`000?oooooooooo017ooooo000=oooo
o`03o`000?oooooooooo043ooooo00?o0000ooooool000002Oooool00ol0003oooooooooo`0Foooo
o`;o00002_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo0_l0000Eoooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0;Oooool3o`0002Sooooo00?o0000oooo
ooooool04_ooool000gooooo00?o0000ooooooooool0@Oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo01Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo02[ooooo0ol0000[ooooo`03o`000?oooooooooo01;ooooo000=ooooo`03o`00
0?oooooooooo043ooooo0_l0000<ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo0_l0000Cooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool09oooool3o`0002gooooo00?o0000ooooooooool0
4oooool000gooooo00?o0000ooooooooool0?oooool01?l0003oooooooooool0000<ooooo`03o`00
0?oooooooooo00oooooo0_l0000=ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
9?ooool3o`0002oooooo00?o0000ooooooooool05?ooool000gooooo00?o0000ooooooooool0?ooo
ool01Ol0003ooooooooooooooooo000000_ooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`0?ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool08?ooool4o`00037ooooo
00?o0000ooooooooool05Oooool000gooooo00?o0000ooooooooool0?_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02oooool2o`0000oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`;o00003oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo01gooooo0ol0000dooooo`03o`000?oooooooooo01Kooooo000=
ooooo`03o`000?oooooooooo03gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo01[ooooo0ol0000gooooo`03o`000?oooooooooo01Kooooo000=oooo
o`03o`000?oooooooooo03cooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00_ooooo0_l0000<ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool05oooool3o`0003Wooooo00?o0000ooooooooool05oooool000gooooo00?o0000oooooooo
ool0>oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool01Oooool2o`0001?ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0Dooooo`?o
0000>oooool00ol0003oooooooooo`0Hooooo`003Oooool00ol0003oooooooooo`0kooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0Aooooo`?o0000
?Oooool00ol0003oooooooooo`0Iooooo`003Oooool00ol0003oooooooooo`0jooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool01Ol0003ooooooooooooooooo000001Gooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`0>ooooo`;o00002?ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00kooooo0ol00010ooooo`03o`000?oooooooooo01Wooooo
000=ooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`0:ooooo`?o00005_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo0ol0
0012ooooo`03o`000?oooooooooo01[ooooo000=ooooo`03o`000?oooooooooo03Sooooo00?o0000
ooooooooool03_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo01Gooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0@ooooo`;o00001Oooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo00Oooooo0ol00014ooooo`03o`000?oooooooooo01_ooooo000=oooo
o`03o`000?oooooooooo03Oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`07oooo
o`;o000000?oooooo`000?ooool05Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo
00Cooooo0ol00016ooooo`03o`000?oooooooooo01cooooo000=ooooo`03o`000?oooooooooo03Oo
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01;o
oooo00Go0000ooooooooooooooooo`00000<ooooo`04o`000?ooooooooooooooo`?o0000BOooool0
0ol0003oooooooooo`0Looooo`003Oooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0Cooooo`;o000000?oooooo`00
0?ooool02oooool4o`0004_ooooo00?o0000ooooooooool07Oooool000gooooo00?o0000oooooooo
ool0=Oooool00ol0003oooooooooo`0Cooooo`04o`000?ooooooooooooooo`;o00001oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool05Oooool2o`00
00Wooooo1?l0001=ooooo`03o`000?oooooooooo01kooooo000=ooooo`03o`000?oooooooooo03Co
oooo00?o0000ooooooooool05Oooool00ol0003oooooo`00000:ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0Eooooo`;o00001Oooool3o`0000?o
oooo00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0Oooooo`003Oooool00ol0003ooooo
ooooo`0cooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool05Oooool01?l0003ooooo
o`000?ooool3o`0000Kooooo00?o0000ooooooooool0B_ooool00ol0003oooooooooo`0Oooooo`00
3Oooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo01Gooooo0_l000000ooooooo0000
ooooo`0:ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`0Eooooo`Co00002Oooool00ol0003oooooooooo`19ooooo`03o`000?oooooooooo023ooooo
000=ooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool05Oooool01Ol0003ooooooooo
oooooooo000000cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo01;ooooo0ol00003ooooo`;o00001oooool00ol0003oooooooooo`18ooooo`03o`00
0?oooooooooo027ooooo000=ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool05?oo
ool2o`0000Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo013ooooo00?o0000ooooooooool03oooool3o`0000;ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo04Oooooo00?o0000ooooooooool08_oo
ool000gooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool03?ooool3o`0000Gooooo00?o0000ooooooooool01?ooool2
o`0000Gooooo00?o0000ooooooooool0A_ooool00ol0003oooooooooo`0Rooooo`003Oooool00ol0
003oooooooooo`0_ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`08ooooo`?o00002?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`0Sooooo`003Oooool00ol0003o
ooooooooo`0_ooooo`03o`000?oooooooooo01;ooooo0_l0000;ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Go
oooo0ol0000;ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00ol00015ooooo`03
o`000?oooooooooo02Cooooo000=ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00;ooooo0ol0000>ooooo`03o`00
0?oooooooooo00Sooooo1_l00013ooooo`03o`000?oooooooooo02Gooooo000=ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool04Oooool2o`00013ooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo01?ooooo1?l0000Aooooo`03o`000?oo
oooooooo00Sooooo1ol00011ooooo`03o`000?oooooooooo02Kooooo000=ooooo`03o`000?oooooo
oooo02cooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0@ooooo`Co00005?ooool0
0ol0003oooooooooo`08ooooo`Oo0000@Oooool00ol0003oooooooooo`0Vooooo`003Oooool00ol0
003oooooooooo`0[ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03_ooool3o`00
00?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`06ooooo`Wo0000@?ooool00ol0
003oooooooooo`0Wooooo`003Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00oo
oooo0_l0000Fooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`0;ooooo`?o00001oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?o
oooo0ol00003ooooo`Go0000@?ooool00ol0003oooooooooo`0Xooooo`003Oooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool05_ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02?ooool3o`0000[ooooo
00?o0000ooooooooool04_ooool00ol0003oooooo`000002o`0000Oooooo0ol00010ooooo`03o`00
0?oooooooooo02Wooooo000=ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool03ooo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo00Go0000oooooooooooooooo
o`000008ooooo`?o00003Oooool00ol0003oooooooooo`0Aooooo`?o0000COooool00ol0003ooooo
ooooo`0Yooooo`003Oooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo00kooooo0_l0
000Looooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00001Oooool3o`00017ooooo
00?o0000ooooooooool03?ooool4o`000003ooooool0003ooooo04cooooo00?o0000ooooooooool0
:_ooool000gooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool02_ooool00ol0003oooooo`000002ooooo`?o00005?oo
ool00ol0003oooooooooo`09ooooo`?o00001Oooool00ol0003oooooooooo`1:ooooo`03o`000?oo
oooooooo02_ooooo000=ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool03?ooool2
o`00023ooooo00?o0000ooooooooool02oooool4o`0001Oooooo00?o0000ooooooooool01_ooool3
o`0000Sooooo00?o0000ooooooooool0BOooool00ol0003oooooooooo`0/ooooo`003Oooool00ol0
003oooooooooo`0Vooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool08Oooool00ol0
003oooooooooo`08ooooo`?o00006oooool00ol0003oooooooooo`02ooooo`?o00002oooool00ol0
003oooooooooo`19ooooo`03o`000?oooooooooo02cooooo000=ooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00Co
oooo0ol00002ooooo`;o00006_ooool00ol0003oooooo`000002o`0000kooooo00?o0000oooooooo
ool0B?ooool00ol0003oooooooooo`0]ooooo`003Oooool00ol0003oooooooooo`0Tooooo`03o`00
0?oooooooooo00_ooooo0_l0000Vooooo`04o`000?ooooooooooooooo`?o00001?ooool01?l0003o
ooooooooool0000Gooooo`Co00004Oooool00ol0003oooooooooo`17ooooo`03o`000?oooooooooo
02kooooo000=ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`0Wooooo`?o00001oooool01Ol0003ooooooooooooooooo000001?ooooo0ol00003oooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool0A_ooool00ol0003oooooooooo`0_oooo
o`003Oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00Wooooo0_l0000Vooooo`Co
000000?oooooo`000?ooool01oooool01Ol0003ooooooooooooooooo0000013ooooo0ol00006oooo
o`03o`000?oooooooooo00oooooo00?o0000ooooooooool0A_ooool00ol0003oooooooooo`0_oooo
o`003Oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool08oooool3o`0000Kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00[ooooo0ol00009ooooo`03o`000?oooooooooo00oooooo00?o0000oooooooo
ool0AOooool00ol0003oooooooooo`0`ooooo`003Oooool00ol0003oooooooooo`0Qooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool08Oooool3o`0000Wooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Kooooo0ol0000=ooooo`03o`00
0?oooooooooo00kooooo00?o0000ooooooooool0A?ooool00ol0003oooooooooo`0aooooo`003Ooo
ool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00Sooooo0_l0000Qooooo`?o00003Ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooooooo
1?l0000@ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0@oooool00ol0003ooooo
ooooo`0booooo`003Oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool07_ooool3o`00017ooooo00Go0000ooooooooooooooooo`000008ooooo`Co0000
5?ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo04?ooooo00?o0000ooooooooool0
<_ooool000gooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo01cooooo0ol0000Dooooo`03o`000?oooooo000000;o00001_ooool4o`0001Oooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`12ooooo`03o`000?oooooooooo03?ooooo000=
ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool01_ooool2o`0001cooooo0ol0000H
ooooo`Go00000_ooool3o`0000Cooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo047ooooo00?o0000ooooooooool0=?ooool000gooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo01Wooooo0ol0000Joooo
o`So00002?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool0@?ooool00ol0003oooooooooo`0eooooo`003Oooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Gooooo0_l0000Iooooo`?o00007Oooool7o`0000Wooooo00?o0000oooooooo
ool05?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo03oooooo00?o0000oooooooo
ool0=_ooool000gooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo01Kooooo0ol0000Pooooo`Oo00002_ooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0?oooool00ol0003oooooooooo`0fooooo`003Ooo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool05?oo
ool3o`0002Cooooo1Ol0000<ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0nooooo`03o`000?oooooooooo03Oooooo000=ooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool00oooool2o`0001Cooooo0ol0000Xooooo`?o00003Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0?Oooool0
0ol0003oooooooooo`0hooooo`003Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool04?ooool4o`0003cooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo03cooooo00?o0000ooooooooool0>Oooool000go
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00ko
oooo0ol00011ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`0looooo`03o`000?oooooooooo03Wooooo000=ooooo`03o`000?oooooooooo01Oooooo
00?o0000ooooooooool00_ooool2o`0000kooooo0ol00015ooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0kooooo`03o`000?oooooooooo03[ooooo
000=ooooo`03o`000?oooooooooo01Oooooo00Go0000ooooooooooooooooo`00000=ooooo`?o0000
B?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
>_ooool00ol0003oooooooooo`0kooooo`003Oooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo00;o00002oooool3o`0004cooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool0??ooool000gooooo00?o0000
ooooooooool05Oooool01?l0003oooooooooool0000:ooooo`?o0000D?ooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0>Oooool00ol0003ooooooooo
o`0looooo`003Oooool00ol0003oooooooooo`0Dooooo`04o`000?ooooooooooo`0000Sooooo0ol0
001Dooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`0hooooo`03o`000?oooooooooo03gooooo000=ooooo`03o`000?oooooooooo01?ooooo00Co0000
ooooool0003o00001_ooool3o`0005Oooooo00?o0000ooooooooool03oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0?_ooool000gooooo00?o0000
ooooooooool04oooool2o`0000Gooooo0ol0001Kooooo`03o`000?oooooooooo00kooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo03oooooo000=oooo
o`03o`000?oooooooooo00kooooo0ol000000ooooooo0000o`000003ooooo`?o0000Goooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0=Oooool00ol0
003oooooooooo`0oooooo`003Oooool00ol0003oooooooooo`0=ooooo`Go00000_ooool3o`0006?o
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo03Co
oooo00?o0000ooooooooool0@?ooool000gooooo00?o0000ooooooooool03?ooool8o`0006Kooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo03?ooooo
00?o0000ooooooooool0@Oooool000gooooo00?o0000ooooooooool03?ooool7o`0006Sooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo03;ooooo00?o
0000ooooooooool0@_ooool000gooooo00?o0000ooooooooool03?ooool7o`0006Wooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo03;ooooo00?o0000
ooooooooool0@_ooool000gooooo00?o0000ooooooooool02_ooool2o`000003ooooool0003o0000
00?o0000Joooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool0<Oooool00ol0003oooooooooo`13ooooo`003Oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00;ooooo0ol0001/ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo04Cooooo000=ooooo`03o`00
0?oooooooooo00Oooooo0_l0001eooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo04Gooooo000=ooooo`03o`000?oo
oooooooo00Gooooo0_l0001hooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo04Gooooo000=ooooo`03o`000?oooooo
oooo00?ooooo0_l0001kooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`0^ooooo`03o`000?oooooooooo04Kooooo000<ooooo`?o00000_ooool2o`00
07gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
02gooooo00?o0000ooooooooool0Aoooool000_ooooo1_l00020ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo04So
oooo000:ooooo`Oo0000POooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0:oooool00ol0003oooooooooo`19ooooo`002_ooool7o`0008;ooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02_ooooo00?o
0000ooooooooool0BOooool000[ooooo2Ol00020ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo04[ooooo000;oooo
o`Go00000oooool3o`0007kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0Boooool000cooooo0ol00007ooooo`Co
0000Noooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0:?ooool00ol0003oooooooooo`1<ooooo`006_ooool3o`0007Wooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0
C?ooool001gooooo0ol0001fooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo04gooooo000Pooooo`?o0000M?ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`1>ooooo`008oooool4o`00077ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0Coooool002Oo
oooo0ol0001_ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo04oooooo000Zooooo`?o0000K?ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool09?ooool00ol0003ooooo
ooooo`1@ooooo`00;Oooool4o`0006Wooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0DOooool0037ooooo0ol0001W
ooooo`03o`000?oooooooooo00Cooooo00Go0000ooooooooooooooooo`00000Tooooo`03o`000?oo
oooooooo05;ooooo000dooooo`?o0000I?ooool00ol0003oooooooooo`04ooooo`05o`000?oooooo
ooooooooool000009?ooool00ol0003oooooooooo`1Booooo`00=oooool3o`0006;ooooo00?o0000
ooooooooool00oooool01Ol0003ooooooooooooooooo000002?ooooo00?o0000ooooooooool0Dooo
ool003[ooooo1?l0001Oooooo`03o`000?oooooooooo00?ooooo00Go0000ooooooooooooooooo`00
000Qooooo`03o`000?oooooooooo05Cooooo000nooooo`?o0000GOooool00ol0003oooooooooo`02
ooooo`05o`000?ooooooooooooooool000008?ooool00ol0003oooooooooo`1Eooooo`00@Oooool3
o`0005[ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000023ooooo00?o
0000ooooooooool0EOooool004Cooooo1?l0001Gooooo`03o`000?oooooooooo00;ooooo00Co0000
oooooooooooo00007oooool00ol0003oooooooooo`1Fooooo`00B?ooool3o`0005Gooooo00Go0000
ooooooooooooooooo`000002ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0Eooo
ool004_ooooo0ol0001Cooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06ooo
ool00ol0003oooooooooo`1Hooooo`00C_ooool3o`00053ooooo00Oo0000ooooooooooooooooo`00
0?oooooo000001cooooo00?o0000ooooooooool0FOooool0057ooooo1?l0001=ooooo`06o`000?oo
ooooooooo`000?oooooo00007?ooool00ol0003oooooooooo`1Iooooo`00EOooool3o`0004_ooooo
00Go0000ooooool0003oooooo`00000Kooooo`03o`000?oooooooooo05[ooooo001Hooooo`?o0000
BOooool01?l0003oooooo`000?l0000Jooooo`03o`000?oooooooooo05_ooooo001Kooooo`Co0000
AOooool00ol0003oooooo`000002o`0001Sooooo00?o0000ooooooooool0G?ooool005oooooo0ol0
0013ooooo`Go00005oooool00ol0003oooooooooo`1Looooo`00H_ooool3o`0003oooooo1ol0000E
ooooo`03o`000?oooooooooo05gooooo001Uooooo`?o0000??ooool7o`0001Cooooo00?o0000oooo
ooooool0G_ooool006Sooooo1?l0000hooooo`Oo00004oooool00ol0003oooooooooo`1Oooooo`00
K?ooool3o`0003Kooooo1Ol0000Dooooo`03o`000?oooooooooo05oooooo001_ooooo`?o0000=?oo
ool3o`0001Cooooo00?o0000ooooooooool0H?ooool007;ooooo1?l0000booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool0HOooool007Kooooo0ol0000_ooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool0H_ooool007Wooooo0ol0000]ooooo`03o`000?oooooooooo00oo
oooo00?o0000ooooooooool0H_ooool007cooooo0ol0000Zooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool0Hoooool007oooooo1?l0000Vooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0I?ooool008?ooooo0ol0000Tooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool0IOooool008Kooooo0ol0000Qooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool0IOooool008Wooooo1?l0000Mooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool0I_ooool008gooooo0ol0000Kooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
Ioooool0093ooooo0ol0000Hooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0J?oo
ool009?ooooo0ol0000Eooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0JOooool0
09Kooooo1?l0000Booooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0JOooool009[o
oooo0ol0000?ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0J_ooool009gooooo
0ol0000<ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0Joooool00:3ooooo1?l0
0009ooooo`05o`000?ooooooooooooooool00000K_ooool00:Cooooo0ol00006ooooo`?o000000?o
ooooo`000?ooool0KOooool00:Oooooo0ol00002ooooo`Go0000Koooool00:[ooooo2?l0001^oooo
o`00Zoooool7o`0006kooooo002[ooooo`Oo0000K_ooool00:cooooo1Ol0001_ooooo`00[Oooool3
o`00073ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003o
ooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003o
ooooob7ooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {0.0110188, -0.0500055, \
0.00362016, 0.00378853}},
  CellTags->{"b:5", "LocalInteractions:12"}]
}, Open  ]]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"5.0 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 701}},
WindowSize->{520, 578},
WindowMargins->{{Automatic, 99}, {28, Automatic}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "b:5"->{
    Cell[1776, 53, 76, 1, 38, "ObjectName",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[1855, 56, 409, 13, 48, "Usage",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[2267, 71, 293, 7, 40, "Notes",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[2585, 82, 78, 1, 38, "ExampleSection",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[2688, 87, 131, 3, 26, "Input",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[2822, 92, 31309, 471, 294, 1283, 95, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[34146, 566, 126, 3, 26, "Input",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[34275, 571, 281, 7, 40, "Text",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[34581, 582, 958, 16, 266, "Input",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[35542, 600, 455, 9, 25, "Output",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[36034, 614, 120, 3, 26, "Input",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[36157, 619, 48063, 708, 294, 1726, 130, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"b:5", "LocalInteractions:12"}]},
  "LocalInteractions:12"->{
    Cell[1776, 53, 76, 1, 38, "ObjectName",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[1855, 56, 409, 13, 48, "Usage",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[2267, 71, 293, 7, 40, "Notes",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[2585, 82, 78, 1, 38, "ExampleSection",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[2688, 87, 131, 3, 26, "Input",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[2822, 92, 31309, 471, 294, 1283, 95, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[34146, 566, 126, 3, 26, "Input",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[34275, 571, 281, 7, 40, "Text",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[34581, 582, 958, 16, 266, "Input",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[35542, 600, 455, 9, 25, "Output",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[36034, 614, 120, 3, 26, "Input",
      CellTags->{"b:5", "LocalInteractions:12"}],
    Cell[36157, 619, 48063, 708, 294, 1726, 130, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"b:5", "LocalInteractions:12"}]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"b:5", 84879, 1348},
  {"LocalInteractions:12", 86122, 1375}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 76, 1, 38, "ObjectName",
  CellTags->{"b:5", "LocalInteractions:12"}],
Cell[1855, 56, 409, 13, 48, "Usage",
  CellTags->{"b:5", "LocalInteractions:12"}],
Cell[2267, 71, 293, 7, 40, "Notes",
  CellTags->{"b:5", "LocalInteractions:12"}],

Cell[CellGroupData[{
Cell[2585, 82, 78, 1, 38, "ExampleSection",
  CellTags->{"b:5", "LocalInteractions:12"}],

Cell[CellGroupData[{
Cell[2688, 87, 131, 3, 26, "Input",
  CellTags->{"b:5", "LocalInteractions:12"}],
Cell[2822, 92, 31309, 471, 294, 1283, 95, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->{"b:5", "LocalInteractions:12"}]
}, Open  ]],
Cell[34146, 566, 126, 3, 26, "Input",
  CellTags->{"b:5", "LocalInteractions:12"}],
Cell[34275, 571, 281, 7, 40, "Text",
  CellTags->{"b:5", "LocalInteractions:12"}],

Cell[CellGroupData[{
Cell[34581, 582, 958, 16, 266, "Input",
  CellTags->{"b:5", "LocalInteractions:12"}],
Cell[35542, 600, 455, 9, 25, "Output",
  CellTags->{"b:5", "LocalInteractions:12"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[36034, 614, 120, 3, 26, "Input",
  CellTags->{"b:5", "LocalInteractions:12"}],
Cell[36157, 619, 48063, 708, 294, 1726, 130, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->{"b:5", "LocalInteractions:12"}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

