// Decompiled by Jad v1.5.8c. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Graph.java

import java.awt.Color;
import java.io.*;
import java.util.StringTokenizer;
import java.util.Vector;
import java.lang.reflect.*;
import com.wolfram.jlink.*;

public class GEGraph
{

    public GEGraph()
    {
        maxX = 2.0F;
        maxY = 2.0F;
        minX = -2F;
        minY = -2F;
        vertices = new Vector();
        edges = new Vector();
        M = 0;
        V = 0;
        directed = false;
    }

    public void addVertex(float f, float f1)
    {
        vertices.add(V, new GEVertex(f, f1));
        V++;
    }

	public void addEdges(int edges[][], Color c) {
		int i;
		for (i=0; i<Array.getLength(edges); i++) {
			addEdge( edges[i][0], edges[i][1], c );
		}
	}
	
	public void addEdge(int i, int j, Color c) {
        if(i >= V || j >= V || vertices.elementAt(i) == null || vertices.elementAt(j) == null) {
            return;
        } 
		else {
            GEEdge edge = new GEEdge((GEVertex)vertices.elementAt(i), (GEVertex)vertices.elementAt(j));
			edge.color = c;
            edges.add(M, edge);
            M++;
            return;
        }
	}
	
    public void addEdge(int i, int j) {
		addEdge(i, j, Color.black );
		/*
        if(i >= V || j >= V || vertices.elementAt(i) == null || vertices.elementAt(j) == null)
        {
            return;
        } else
        {
            GEEdge edge = new GEEdge((GEVertex)vertices.elementAt(i), (GEVertex)vertices.elementAt(j));
            edges.add(M, edge);
            M++;
            return;
        }
		*/
    }

	public void deleteAllEdges() {
		edges = new Vector();
		M = 0;
	}
	
    public void deleteEdge(int i)
    {
        if(i != -1)
        {
            edges.remove(i);
            M--;
        }
    }

    public void deleteVertex(int i)
    {
        GEVertex vertex = (GEVertex)vertices.remove(i);
        for(int j = 0; j < M; j++)
        {
            GEEdge edge = (GEEdge)edges.elementAt(j);
            if(edge.v1.equals(vertex) || edge.v2.equals(vertex))
            {
                edges.remove(j);
                M--;
                j--;
            }
        }

        V--;
    }
	
	public void readGraphFromExpr(Expr e) {
		final boolean printStatements = false;
		
		Expr graphEdges = e.part(1);
		Expr graphVertices= e.part(2);
		System.out.println("Number of edges: " + graphEdges.length());
		System.out.println("Number of vertices: " + graphVertices.length());
		M = graphEdges.length();
		V = graphVertices.length();
		
		vertices.clear();
		edges.clear();
		
		int i;
		try {
			// Parse vertices
			for	(i=1; i <= graphVertices.length(); i++) {
				vertices.add( parseVertex( graphVertices.part(i) ) ); // The full edge expression
			}
		
			// Parse edges
			for	(i=1; i <= graphEdges.length(); i++) {
				edges.add( parseEdge( graphEdges.part(i) ) );
				//Expr edge = graphEdges.part(i); // The full edge expression
				/*
				int one = edge.part( new int[] {1, 1} ).asInt() - 1;
				int two = edge.part( new int[] {1, 2} ).asInt() - 1;

				if (printStatements)
					System.out.println("Edge connecting vertex " + one + " to vertex " + two);
			
				int j;
				String label = "";
				float weight = 1.0F;
				Color color = Color.black;
				// Now parse any addition Rules which apply to the edge
				for (j=2; j <= edge.length(); j++) {
					Expr subExpr = edge.part(j); // grab the jth subexpression (typically a rule)
					Expr head = subExpr.head();
					if (head.toString().equals("Rule")) {
						String symbol = subExpr.part(1).toString(); // the symbol of the rule
						if (symbol.equals("EdgeWeight")) {
							// process edgeweight
							weight = (float) subExpr.part(2).asDouble();
							if (printStatements)
								System.out.println("	Edge has weight " + weight);
						}
						else if (symbol.equals("EdgeColor")) {
							// process edgecolor
							Expr c = subExpr.part(2);
							float red   = (float) c.part(1).asDouble();
							float green = (float) c.part(2).asDouble();
							float blue  = (float) c.part(3).asDouble();
							color = new Color( red, green, blue );
							if (printStatements)
								System.out.println("	Edge has color: " + color.toString());
						}
						else if  (symbol.equals("EdgeLabel")) {
							label = subExpr.part(2).asString();
							if (printStatements)
								System.out.println("	Edge has label " + label);
						}
					}
				}
				GEVertex v1 = (GEVertex)vertices.elementAt(one);
				GEVertex v2 = (GEVertex)vertices.elementAt(two);
				GEEdge theEdge = new GEEdge(v1,v2);
				theEdge.label = label;
				theEdge.color = color;
				theEdge.weight = weight;
				edges.add(theEdge);
				 */
			}
		} catch (ExprFormatException ex) {
			System.out.println("Expr format error in GEGraph readGraphFromExpr");
		}
	}

	GEVertex parseVertex(Expr vertex) throws ExprFormatException {
		final boolean printStatements = false;
		/*
		 A vertex has the form {{x,y}, Rule[Foo1, Bar1], Rule[Foo2, Bar2],..., Rule[FooN, BarN]}
		 */
		float x = (float) vertex.part( new int[] {1,1} ).asDouble();
		float y = (float) vertex.part( new int[] {1,2} ).asDouble();
		y = -y;
		
		if (printStatements)
			System.out.println("Vertex has coordinates (" + x + "," + y + ")");
		
		int j;
		float weight = 0.0F;
		Color color = Color.black;
		String label = "";
		// Now parse any rules which apply to the vertex
		for (j=2; j <= vertex.length(); j++) {
			Expr subExpr = vertex.part(j); // grab the jth subexpression (typically a rule)
			Expr head = subExpr.head();
			if (head.toString().equals("Rule")) {
				
				String symbol = subExpr.part(1).toString(); // the symbol of the rule
				
				if (symbol.equals("VertexColor")) {
					// process vertex color
					Expr c = subExpr.part(2);
					float red   = (float) c.part(1).asDouble();
					float green = (float) c.part(2).asDouble();
					float blue  = (float) c.part(3).asDouble();
					color = new Color( red, green, blue );
					if (printStatements)
						System.out.println("	Vertex color: " + color.toString());
				}
				else if (symbol.equals("VertexLabel")) {
					// process vertex color
					label = subExpr.part(2).asString();
					if (printStatements)
						System.out.println("	Vertex label: " + label);
				}
				else if (symbol.equals("VertexWeight")) {
					// process vertex color
					weight = (float) subExpr.part(2).asDouble();
					if (printStatements)
						System.out.println("	Vertex weight: " + weight);						
				}
			}
		}
		GEVertex v = new GEVertex(x,y);
		v.color = color;
		v.label = label;
		v.weight = weight;
		return v;
	}
	
	GEEdge parseEdge(Expr edge) throws ExprFormatException {
		final boolean printStatements = false;
		/*
		 An edge has the form {{v1,v2}, Rule[Foo1, Bar1], Rule[Foo2, Bar2],..., Rule[FooN, BarN]}
		 */
		int one = edge.part( new int[] {1,1} ).asInt() - 1;
		int two = edge.part( new int[] {1,2} ).asInt() - 1;
		
		if (printStatements)
			System.out.println("Edge connecting vertex " + one + " to vertex " + two);
		
		int j;
		String label = "";
		float weight = 1.0F;
		Color color = Color.black;
		// Now parse any addition Rules which apply to the edge
		for (j=2; j <= edge.length(); j++) {
			Expr subExpr = edge.part(j); // grab the jth subexpression (typically a rule)
			Expr head = subExpr.head();
			if (head.toString().equals("Rule")) {
				String symbol = subExpr.part(1).toString(); // the symbol of the rule
				if (symbol.equals("EdgeWeight")) {
					// process edgeweight
					weight = (float) subExpr.part(2).asDouble();
					if (printStatements)
						System.out.println("	Edge has weight " + weight);
				}
				else if (symbol.equals("EdgeColor")) {
					// process edgecolor
					Expr c = subExpr.part(2);
					float red   = (float) c.part(1).asDouble();
					float green = (float) c.part(2).asDouble();
					float blue  = (float) c.part(3).asDouble();
					color = new Color( red, green, blue );
					if (printStatements)
						System.out.println("	Edge has color: " + color.toString());
				}
				else if  (symbol.equals("EdgeLabel")) {
					label = subExpr.part(2).asString();
					if (printStatements)
						System.out.println("	Edge has label " + label);
				}
			}
		}
		GEVertex v1 = (GEVertex)vertices.elementAt(one);
		GEVertex v2 = (GEVertex)vertices.elementAt(two);
		GEEdge theEdge = new GEEdge(v1,v2);
		theEdge.label = label;
		theEdge.color = color;
		theEdge.weight = weight;
		return theEdge;
	}
	
	public void readGraphFromString(String s) {
        int i = 0;
        String s1 = "";
        String s2 = "";
        int j = 1;
        vertices.clear();
        edges.clear();
        M = 0;
        V = 0;
        directed = false;
        
        for(int k = 7; k < s.length(); k++)
        {
            char c = s.charAt(k);
            if(c == '{')
                j++;
            else
				if(c == '}')
					j--;
            if(j != 0)
                continue;
            i = k;
            break;
        }
		
        s1 = s.substring(6, i);
        s2 = s.substring(i + 1, s.length() - 2);
        vertexParser(s2);
        edgeParser(s1);
        if(s.endsWith("EdgeDirection -> On]") || s.endsWith("EdgeDirection->On]") || s.endsWith("EdgeDirection-> On]") || s.endsWith("EdgeDirection -> On]"))
            directed = true;		
	}
	
    public void readGraph(File file)
    {
        String s = "";
        int i = 0;
        String s1 = "";
        String s2 = "";
        int j = 1;
        vertices.clear();
        edges.clear();
        M = 0;
        V = 0;
        directed = false;
        try
        {
            FileReader filereader = new FileReader(file);
            for(int l = 0; (l = filereader.read()) != -1;)
                s = s + (char)l;

        }
        catch(IOException ioexception)
        {
            System.out.println(ioexception);
        }
        for(int k = 7; k < s.length(); k++)
        {
            char c = s.charAt(k);
            if(c == '{')
                j++;
            else
            if(c == '}')
                j--;
            if(j != 0)
                continue;
            i = k;
            break;
        }

        s1 = s.substring(6, i);
        s2 = s.substring(i + 1, s.length() - 2);
        vertexParser(s2);
        edgeParser(s1);
        if(s.endsWith("EdgeDirection -> On]") || s.endsWith("EdgeDirection->On]") || s.endsWith("EdgeDirection-> On]") || s.endsWith("EdgeDirection -> On]"))
            directed = true;
    }

    private void vertexParser(String s)
    {
        int i = 0;
        boolean flag = false;
        String s1 = "";
        for(int j = 0; j < s.length(); j++)
        {
            char c = s.charAt(j);
            if(c == '{')
                i++;
            else
            if(c == '}')
            {
                i--;
                flag = true;
            }
            if(i == 1)
            {
                if(flag)
                {
                    parseVertex(s1);
                    flag = false;
                }
                s1 = "";
            } else
            if(i > 1)
                s1 = s1 + c;
        }

    }

    private void parseVertex(String s)
    {
        String s1 = "";
        StringTokenizer stringtokenizer = new StringTokenizer(s, ",");
        String s2 = stringtokenizer.nextToken();
        for(int i = 0; i < s2.length(); i++)
        {
            char c = s2.charAt(i);
            if(c <= '9' && c >= '0' || c == '.' || c == '-')
                s1 = s1 + c;
        }

        //float f = Float.parseFloat(s1);
		float f = (float) Double.parseDouble(s1);
        if(f > maxX)
            maxX = f;
        if(f < minX)
            minX = f;
        s1 = "";
        s2 = stringtokenizer.nextToken();
        for(int j = 0; j < s2.length(); j++)
        {
            char c1 = s2.charAt(j);
            if(c1 <= '9' && c1 >= '0' || c1 == '.' || c1 == '-')
                s1 = s1 + c1;
        }

        float f1 = Float.parseFloat(s1);
        f1 = -f1;
        if(f1 > maxY)
            maxY = f1;
        if(f1 < minY)
            minY = f1;
        s1 = "";
        addVertex(f, f1);
        while(stringtokenizer.hasMoreTokens()) 
        {
            String s3 = stringtokenizer.nextToken();
            int k = s3.lastIndexOf("VertexWeight -> ");
            if(k != -1)
            {
                k += 16;
                GEVertex vertex = (GEVertex)vertices.elementAt(V - 1);
                try
                {
                    vertex.weight = Float.parseFloat(s3.substring(k));
                }
                catch(Exception exception1)
                {
                    vertex.weight = 0.0F;
                }
            } else
            {
                int l = s3.lastIndexOf("VertexLabel -> ");
                if(l != -1)
                {
                    l += 15;
                    GEVertex vertex1 = (GEVertex)vertices.elementAt(V - 1);
                    vertex1.label = s3.substring(l);
                } else
                {
                    int i1 = s3.lastIndexOf("VertexStyle -> Disc[Large]");
                    if(i1 != -1)
                    {
                        GEVertex vertex2 = (GEVertex)vertices.elementAt(V - 1);
                        vertex2.style = "Large";
                    } else
                    {
                        int j1 = s3.lastIndexOf("VertexColor -> RGBColor[");
                        if(j1 != -1)
                            try
                            {
                                j1 += 24;
                                float f2 = Float.parseFloat(s3.substring(j1));
                                s3 = stringtokenizer.nextToken();
                                float f3 = Float.parseFloat(s3);
                                s3 = stringtokenizer.nextToken();
                                float f4 = Float.parseFloat(s3.substring(0, s3.length() - 2));
                                GEVertex vertex3 = (GEVertex)vertices.elementAt(V - 1);
                                vertex3.color = new Color(f2, f3, f4);
                            }
                            catch(Exception exception) { }
                    }
                }
            }
        }
    }

    private void edgeParser(String s)
    {
        int i = 0;
        String s1 = "";
        boolean flag = false;
        for(int j = 0; j < s.length(); j++)
        {
            char c = s.charAt(j);
            if(c == '{')
                i++;
            else
            if(c == '}')
            {
                flag = true;
                i--;
            }
            if(i == 1)
            {
                if(flag)
                {
                    flag = false;
                    parseEdge(s1);
                }
                s1 = "";
            } else
            if(i > 1)
                s1 = s1 + c;
        }

    }

    private void parseEdge(String s)
    {
        String s1 = "";
        StringTokenizer stringtokenizer = new StringTokenizer(s, ",");
        String s2 = stringtokenizer.nextToken();
        for(int k = 0; k < s2.length(); k++)
        {
            char c = s2.charAt(k);
            if(c <= '9' && c >= '0')
                s1 = s1 + c;
        }

        int i = Integer.parseInt(s1);
        i--;
        s1 = "";
        s2 = stringtokenizer.nextToken();
        for(int l = 0; l < s2.length(); l++)
        {
            char c1 = s2.charAt(l);
            if(c1 <= '9' && c1 >= '0')
                s1 = s1 + c1;
        }

        int j = Integer.parseInt(s1);
        j--;
        s1 = "";
        addEdge(i, j);
        while(stringtokenizer.hasMoreTokens()) 
        {
            String s3 = stringtokenizer.nextToken();
            int i1 = s3.lastIndexOf("EdgeColor -> ");
            if(i1 != -1)
            {
                i1 += 13;
                if(s3.substring(i1, i1 + 9).equals("RGBColor["))
                    try
                    {
                        float f = Float.parseFloat(s3.substring(i1 + 9));
                        s3 = stringtokenizer.nextToken();
                        float f1 = Float.parseFloat(s3);
                        s3 = stringtokenizer.nextToken();
                        float f2 = Float.parseFloat(s3.substring(0, s3.length() - 2));
                        GEEdge edge13 = (GEEdge)edges.elementAt(M - 1);
                        edge13.color = new Color(f, f1, f2);
						//System.out.println("New edge color: " + edge13.color.toString());
                    }
                    catch(Exception exception) { 
						System.out.println(exception.getMessage());
					}
                else
                if(s3.substring(i1).equalsIgnoreCase("Red"))
                {
                    GEEdge edge = (GEEdge)edges.elementAt(M - 1);
                    edge.color = Color.red;
                } else
                if(s3.substring(i1).equalsIgnoreCase("White"))
                {
                    GEEdge edge1 = (GEEdge)edges.elementAt(M - 1);
                    edge1.color = Color.white;
                } else
                if(s3.substring(i1).equalsIgnoreCase("blue"))
                {
                    GEEdge edge2 = (GEEdge)edges.elementAt(M - 1);
                    edge2.color = Color.blue;
                } else
                if(s3.substring(i1).equalsIgnoreCase("cyan"))
                {
                    GEEdge edge3 = (GEEdge)edges.elementAt(M - 1);
                    edge3.color = Color.cyan;
                } else
                if(s3.substring(i1).equalsIgnoreCase("gray"))
                {
                    GEEdge edge4 = (GEEdge)edges.elementAt(M - 1);
                    edge4.color = Color.gray;
                } else
                if(s3.substring(i1).equalsIgnoreCase("green"))
                {
                    GEEdge edge5 = (GEEdge)edges.elementAt(M - 1);
                    edge5.color = Color.green;
                } else
                if(s3.substring(i1).equalsIgnoreCase("magenta"))
                {
                    GEEdge edge6 = (GEEdge)edges.elementAt(M - 1);
                    edge6.color = Color.magenta;
                } else
                if(s3.substring(i1).equalsIgnoreCase("orange"))
                {
                    GEEdge edge7 = (GEEdge)edges.elementAt(M - 1);
                    edge7.color = Color.orange;
                } else
                if(s3.substring(i1).equalsIgnoreCase("pink"))
                {
                    GEEdge edge8 = (GEEdge)edges.elementAt(M - 1);
                    edge8.color = Color.pink;
                } else
                if(s3.substring(i1).equalsIgnoreCase("yellow"))
                {
                    GEEdge edge9 = (GEEdge)edges.elementAt(M - 1);
                    edge9.color = Color.yellow;
                }
            } else
            {
                int j1 = s3.lastIndexOf("EdgeLabel -> ");
                if(j1 != -1)
                {
                    j1 += 13;
                    GEEdge edge10 = (GEEdge)edges.elementAt(M - 1);
                    edge10.label = s3.substring(j1);
                } else
                {
                    int k1 = s3.lastIndexOf("EdgeWeight -> ");
                    if(k1 != -1)
                    {
                        k1 += 14;
                        GEEdge edge11 = (GEEdge)edges.elementAt(M - 1);
                        try
                        {
                            edge11.weight = Float.parseFloat(s3.substring(k1));
                        }
                        catch(Exception exception1)
                        {
                            edge11.weight = 0.0F;
                        }
                    } else
                    {
                        int l1 = s3.lastIndexOf("EdgeStyle -> ");
                        if(l1 != -1)
                        {
                            l1 += 13;
                            GEEdge edge12 = (GEEdge)edges.elementAt(M - 1);
                            edge12.style = s3.substring(l1);
                        }
                    }
                }
            }
        }
    }

    public float getX(int i)
    {
        GEVertex vertex = (GEVertex)vertices.elementAt(i);
        return vertex.x;
    }

    public float getY(int i)
    {
        GEVertex vertex = (GEVertex)vertices.elementAt(i);
        return vertex.y;
    }

    public float getX1(int i)
    {
        GEEdge edge = (GEEdge)edges.elementAt(i);
        return edge.v1.x;
    }

    public float getX2(int i)
    {
        GEEdge edge = (GEEdge)edges.elementAt(i);
        return edge.v2.x;
    }

    public float getY1(int i)
    {
        GEEdge edge = (GEEdge)edges.elementAt(i);
        return edge.v1.y;
    }

    public float getY2(int i)
    {
        GEEdge edge = (GEEdge)edges.elementAt(i);
        return edge.v2.y;
    }

    public Color getVertexColor(int i)
    {
        GEVertex vertex = (GEVertex)vertices.elementAt(i);
        return vertex.color;
    }

    public Color getEdgeColor(int i)
    {
        GEEdge edge = (GEEdge)edges.elementAt(i);
        return edge.color;
    }

    public String getEdgeLabel(int i)
    {
        GEEdge edge = (GEEdge)edges.elementAt(i);
        return edge.label;
    }

    public void setEdgeColor(int i, int j, Color color)
    {
        int k = -1;
        GEVertex vertex = (GEVertex)vertices.elementAt(i);
        GEVertex vertex1 = (GEVertex)vertices.elementAt(j);
        for(int l = 0; l < M; l++)
        {
            GEEdge edge = (GEEdge)edges.elementAt(l);
            if(edge.v1.equals(vertex) && edge.v2.equals(vertex1) || edge.v1.equals(vertex1) && edge.v2.equals(vertex))
                k = l;
        }

        if(k != -1)
        {
            GEEdge edge1 = (GEEdge)edges.elementAt(k);
            edge1.color = color;
        }
    }

    public void setEdgeLabel(int i, int j, String s)
    {
        int k = -1;
        GEVertex vertex = (GEVertex)vertices.elementAt(i);
        GEVertex vertex1 = (GEVertex)vertices.elementAt(j);
        for(int l = 0; l < M; l++)
        {
            GEEdge edge = (GEEdge)edges.elementAt(l);
            if(edge.v1.equals(vertex) && edge.v2.equals(vertex1) || edge.v1.equals(vertex1) && edge.v2.equals(vertex))
                k = l;
        }

        if(k != -1)
        {
            GEEdge edge1 = (GEEdge)edges.elementAt(k);
            edge1.label = s;
        }
    }
	
	public Expr graphToExpr() {
		Expr graphEdges[] = new Expr[M];
		Expr graphVertices[] = new Expr[V];
		
		for(int i = 0; i < M; i++) {
			GEEdge edge = (GEEdge)edges.elementAt(i);
			int k = vertices.indexOf(edge.v1) + 1;
			int l = vertices.indexOf(edge.v2) + 1;
			
			if(l < k && !directed) {
				int i1 = l;
				l = k;
				k = i1;
			}

			Expr pair = ExprFactory.list( k, l );
			Expr edgeExpr = ExprFactory.list( pair );
			
			double r = edge.color.getRed() / 255.0;
			double g = edge.color.getGreen() / 255.0;
			double b = edge.color.getBlue() / 255.0;
			
			Expr newExpr;
			
			if(edge.color.equals(Color.black) == false) {
				Expr rgbColor = ExprFactory.rgbColor( r, g, b );
				Expr edgeColor = ExprFactory.rule("EdgeColor", rgbColor);
				newExpr = edgeExpr.insert(edgeColor, -1);
				edgeExpr.dispose();
				rgbColor.dispose();
				edgeColor.dispose();
				edgeExpr = newExpr;
			}
			if(edge.label.equals("") == false) {
				Expr edgeLabel = ExprFactory.rule("EdgeLabel", new Expr(edge.label));
				newExpr = edgeExpr.insert(edgeLabel, -1);
				edgeExpr.dispose();
				edgeLabel.dispose();
				edgeExpr = newExpr;
			}
			if(edge.weight != 0.0F) {
				Expr edgeWeight = ExprFactory.rule("EdgeWeight", edge.weight);
				newExpr = edgeExpr.insert(edgeWeight, -1);
				edgeExpr.dispose();
				edgeWeight.dispose();
				edgeExpr = newExpr;
			}
			
			graphEdges[i] = edgeExpr;
		}
		
		for(int j = 0; j < V; j++)
		{
			GEVertex vertex = (GEVertex)vertices.elementAt(j);
			double r = vertex.color.getRed() / 255.0;
			double g = vertex.color.getGreen() / 255.0;
			double b = vertex.color.getBlue() / 255.0;
			
			Expr vertexExpr = ExprFactory.list(
											   ExprFactory.list( vertex.x, -vertex.y )
											   );
			Expr newExpr;
			if(vertex.color.equals(Color.black) == false) {
				Expr rgbColor = ExprFactory.rgbColor( r, g, b );
				Expr vertexColor = ExprFactory.rule("VertexColor", rgbColor );	
				newExpr = vertexExpr.insert(vertexColor, -1);
				vertexExpr.dispose();
				rgbColor.dispose();
				vertexColor.dispose();
				vertexExpr = newExpr;
			}
			
			if(vertex.weight != 0.0F) {
				Expr vertexWeight = ExprFactory.rule("VertexWeight", vertex.weight);
				newExpr = vertexExpr.insert(vertexWeight, -1);
				vertexWeight.dispose();
				vertexExpr.dispose();
				vertexExpr = newExpr;
			}
			
			if(vertex.label.equals("") == false) {
				Expr vertexLabel = ExprFactory.rule("VertexLabel", new Expr(vertex.label));
				newExpr = vertexExpr.insert(vertexLabel, -1);
				vertexLabel.dispose();
				vertexExpr.dispose();
				vertexExpr = newExpr;
			}
			graphVertices[j] = vertexExpr;
		}
		
		Expr g = ExprFactory.expr("Graph", 
								  ExprFactory.list(graphEdges), 
								  ExprFactory.list(graphVertices)
								  );

		ExprFactory.disposeAll(graphEdges);
		ExprFactory.disposeAll(graphVertices);
		
		return g;
	}
	
	public void sendGraphToMathematica(KernelLink kl) throws MathLinkException {
		kl.putFunction("Graph", 2);
		
		kl.putFunction("List", M);
		for(int i = 0; i < M; i++) {
			GEEdge edge = (GEEdge)edges.elementAt(i);
			int k = vertices.indexOf(edge.v1) + 1;
			int l = vertices.indexOf(edge.v2) + 1;
			
			if(l < k && !directed) {
				int i1 = l;
				l = k;
				k = i1;
			}
			
			int thingsToSend = 1; // The vertices
			if(edge.color.equals(Color.black) == false)
				thingsToSend++;
			if(edge.label.equals("") == false)
				thingsToSend++;
			if(edge.weight != 0.0F)
				thingsToSend++;
			
			kl.putFunction("List", thingsToSend);
			{
				kl.putFunction("List", 2);
				{
					kl.put(k); 
					kl.put(l);
				}
				
				if(edge.color.equals(Color.black) == false) {
					double r = edge.color.getRed() / 255.0;
					double g = edge.color.getGreen() / 255.0;
					double b = edge.color.getBlue() / 255.0;
					kl.putFunction("Rule", 2);
					{
						kl.putSymbol("EdgeColor");
						kl.putFunction("RGBColor", 3);
						{
							kl.put(r); 
							kl.put(g); 
							kl.put(b);					
						}
					}
				}
				if(edge.label.equals("") == false) {
					kl.putFunction("Rule", 2);
					{
						kl.putSymbol("EdgeLabel");
						kl.put(edge.label);
					}
				}
				if(edge.weight != 0.0F) {
					kl.putFunction("Rule", 2);
					{
						kl.putSymbol("EdgeWeight");
						kl.put(edge.weight);
					}
				}
			}
		}
		
		kl.putFunction("List", V);
		for(int j = 0; j < V; j++)
		{
			GEVertex vertex = (GEVertex)vertices.elementAt(j);
			
			int thingsToSend = 1; // The coordinates
			if(vertex.color.equals(Color.black) == false) 
				thingsToSend++;
			if(vertex.weight != 0.0F)
				thingsToSend++;
			if(vertex.label.equals("") == false)
				thingsToSend++;
						
			kl.putFunction("List", thingsToSend);
			{
				kl.putFunction("List", 2);
				kl.put( vertex.x );
				kl.put( -vertex.y );
			}

			if(vertex.color.equals(Color.black) == false) {
				double r = vertex.color.getRed() / 255.0;
				double g = vertex.color.getGreen() / 255.0;
				double b = vertex.color.getBlue() / 255.0;
				kl.putFunction("Rule", 2);
				{
					kl.putSymbol("VertexColor");
					kl.putFunction("RGBColor", 3);
					{
						kl.put(r);
						kl.put(g);
						kl.put(b);
					}
				}
			}
						
			if(vertex.weight != 0.0F) {
				kl.putFunction("Rule", 2);
				{
					kl.putSymbol("VertexWeight");
					kl.put(vertex.weight);
				}
			}
			
			if(vertex.label.equals("") == false) {
				kl.putFunction("Rule", 2);
				{
					kl.putSymbol("VertexLabel");
					kl.put(vertex.label);
				}
			}
		}
	}
	
	
	public String graphToString() {
		String s = "Graph[{";
		
		for(int i = 0; i < M; i++) {
			GEEdge edge = (GEEdge)edges.elementAt(i);
			int k = vertices.indexOf(edge.v1) + 1;
			int l = vertices.indexOf(edge.v2) + 1;
			float f1 = (float)edge.color.getRed() / 255F;
			float f3 = (float)edge.color.getGreen() / 255F;
			float f5 = (float)edge.color.getBlue() / 255F;
			String s2 = "";
			String s4 = "";
			String s6 = "";
			String s8 = "";
			if(edge.color.equals(Color.black))
				s4 = "";
			else
				s4 = ", EdgeColor -> RGBColor[" + f1 + ", " + f3 + ", " + f5 + "]";
			if(edge.label.equals(""))
				s2 = "";
			else
				s2 = ", EdgeLabel -> " + edge.label;
			if(edge.weight == 0.0F)
				s6 = "";
			else
				s6 = ", EdgeWeight -> " + edge.weight;
			if(edge.style.equals("Normal"))
				s8 = "";
			else
				s8 = ", EdgeStyle -> " + edge.style;
			if(l < k && !directed)
			{
				int i1 = l;
				l = k;
				k = i1;
			}
			if(i > 0)
				s = s + ",\n\t{{" + k + ", " + l + "}" + s4 + s2 + s6 + s8 + "}";
			else
				s = s + "{{" + k + ", " + l + "}" + s4 + s2 + s6 + s8 + "}";
		}
		
		s = s + "},\r\t{";
		for(int j = 0; j < V; j++)
		{
			GEVertex vertex = (GEVertex)vertices.elementAt(j);
			float f = (float)vertex.color.getRed() / 255F;
			float f2 = (float)vertex.color.getGreen() / 255F;
			float f4 = (float)vertex.color.getBlue() / 255F;
			String s1 = "";
			String s3 = "";
			String s5 = "";
			String s7 = "";
			if(vertex.color.equals(Color.black))
				s1 = "";
			else
				s1 = ", VertexColor -> RGBColor[" + f + ", " + f2 + ", " + f4 + "]";
			if(vertex.weight == 0.0F)
				s3 = "";
			else
				s3 = ", VertexWeight -> " + vertex.weight;
			if(vertex.style.equals("Normal"))
				s7 = "";
			else
				s7 = ", VertexStyle -> Disc[Large]";
			if(vertex.label.equals(""))
				s5 = "";
			else
				s5 = ", VertexLabel -> " + vertex.label;
			
			float choppedX = (float) (((int) 10000*vertex.x)/10000.0);
			float choppedY = (float) (((int) 10000*vertex.y)/10000.0);
			
			if(j > 0)
				s = s + ",\n\t{{" + choppedX + ", " + -choppedY + "}" + s1 + s3 + s7 + s5 + "}";
			else
				s = s + "{{" + choppedX + ", " + -choppedY + "}" + s1 + s3 + s7 + s5 + "}";
		}
		
		if(directed)
			s = s + "}, EdgeDirection -> On]";
		else
			s = s + "}]";
		
		System.out.println(s);
		return s;
	}
	
    public void saveGraph(File file)
    {
        String s = "Graph[{";
        try
        {
            FileOutputStream fileoutputstream = new FileOutputStream(file);
            for(int i = 0; i < M; i++)
            {
                GEEdge edge = (GEEdge)edges.elementAt(i);
                int k = vertices.indexOf(edge.v1) + 1;
                int l = vertices.indexOf(edge.v2) + 1;
                float f1 = (float)edge.color.getRed() / 255F;
                float f3 = (float)edge.color.getGreen() / 255F;
                float f5 = (float)edge.color.getBlue() / 255F;
                String s2 = "";
                String s4 = "";
                String s6 = "";
                String s8 = "";
                if(edge.color.equals(Color.black))
                    s4 = "";
                else
                    s4 = ", EdgeColor -> RGBColor[" + f1 + ", " + f3 + ", " + f5 + "]";
                if(edge.label.equals(""))
                    s2 = "";
                else
                    s2 = ", EdgeLabel -> " + edge.label;
                if(edge.weight == 0.0F)
                    s6 = "";
                else
                    s6 = ", EdgeWeight -> " + edge.weight;
                if(edge.style.equals("Normal"))
                    s8 = "";
                else
                    s8 = ", EdgeStyle -> " + edge.style;
                if(l < k && !directed)
                {
                    int i1 = l;
                    l = k;
                    k = i1;
                }
                if(i > 0)
                    s = s + ",\n\t{{" + k + ", " + l + "}" + s4 + s2 + s6 + s8 + "}";
                else
                    s = s + "{{" + k + ", " + l + "}" + s4 + s2 + s6 + s8 + "}";
            }

            s = s + "},\r\t{";
            for(int j = 0; j < V; j++)
            {
                GEVertex vertex = (GEVertex)vertices.elementAt(j);
                float f = (float)vertex.color.getRed() / 255F;
                float f2 = (float)vertex.color.getGreen() / 255F;
                float f4 = (float)vertex.color.getBlue() / 255F;
                String s1 = "";
                String s3 = "";
                String s5 = "";
                String s7 = "";
                if(vertex.color.equals(Color.black))
                    s1 = "";
                else
                    s1 = ", VertexColor -> RGBColor[" + f + ", " + f2 + ", " + f4 + "]";
                if(vertex.weight == 0.0F)
                    s3 = "";
                else
                    s3 = ", VertexWeight -> " + vertex.weight;
                if(vertex.style.equals("Normal"))
                    s7 = "";
                else
                    s7 = ", VertexStyle -> Disc[Large]";
                if(vertex.label.equals(""))
                    s5 = "";
                else
                    s5 = ", VertexLabel -> " + vertex.label;
                if(j > 0)
                    s = s + ",\n\t{{" + vertex.x + ", " + -vertex.y + "}" + s1 + s3 + s7 + s5 + "}";
                else
                    s = s + "{{" + vertex.x + ", " + -vertex.y + "}" + s1 + s3 + s7 + s5 + "}";
            }

            if(directed)
                s = s + "}, EdgeDirection -> On]";
            else
                s = s + "}]";
            fileoutputstream.write(s.getBytes());
        }
        catch(IOException ioexception)
        {
            System.out.println(ioexception);
        }
    }

    public Vector vertices;
    public Vector edges;
    public int M;
    public int V;
    public boolean directed;
    public float maxX;
    public float maxY;
    public float minX;
    public float minY;
}
